
static char rcsid[] = "$Id: g_out.c,v 1.2 1993/03/11 08:05:32 nakano Exp nakano $";

#include    "g_out.h"

M_CTRL      m_ctrl;
float       mat[3][2];

static read_spec();
static print_usage();
static read_frame_no();
static read_width();
static read_mag();

main( argc, argv )
int     argc;
char    *argv[];
{
    read_spec( argc, argv );

    m_open( m_ctrl.mfile, "r" );
    if( m_ctrl.device == 'l' ) {
        lips_form();
	} else if( m_ctrl.device == 'c' ) {
		pict_form();
	      }
          else if( m_ctrl.device == 'i' ) {
	        i88_form();
    } else
        ps_form();
    m_close();
}

/* =============================================================================== */
static read_spec( argc, argv )
int     argc;
char    *argv[];
{
    char    *pc;
    int     arg_pos;

    m_ctrl.mag      =  1.0;
    m_ctrl.frame[0] =  1;
    m_ctrl.frame[1] =  1;
    m_ctrl.width    = -1;
    m_ctrl.vflag    = FALSE;
    m_ctrl.tflow    = FALSE;
    m_ctrl.device   = 'p';

    if( argc < 2 ) {
        print_usage();
        return -1;
    } else if( argc == 2 ) {
        strncpy( m_ctrl.mfile, argv[1]
                , sizeof( m_ctrl.mfile ) - 4 );
        strcpy( m_ctrl.ofile, m_ctrl.mfile );
        strcat( m_ctrl.ofile, ".ps" );
        return 0;
    }

    pc  = argv[1];
    if( *pc++ != '-' ) {
        print_usage();
        return -1;
    }

    arg_pos = 2;
    while( *pc ) {
        switch( *pc++ ) {
        case 'l':   m_ctrl.device = 'l';
                    break;
		case 'c':	m_ctrl.device = 'c';
					break;
         	case 'i':       m_ctrl.device = 'i';
	                                break;
        case 'v':   m_ctrl.vflag = TRUE;
                    break;
        case 'f':   if( arg_pos >= argc ) return -1;
                    if( read_frame_no(argv[arg_pos++]) ) {
                        print_usage();
                        return -1;
                    }
                    break;
        case 'w':   if( arg_pos >= argc ) return -1;
                    if( read_width(argv[arg_pos++]) ) {
                        print_usage();
                        return -1;
                    }
                    break;
        case 't':   m_ctrl.tflow = TRUE;
                    break;
        case 'm':   if( arg_pos >= argc ) return -1;
                    if( read_mag(argv[arg_pos++]) ) {
                        print_usage();
                        return -1;
                    }
                    break;
        default:    print_usage();
                    return -1;

        }   /* switch */
        }   /* while */
        if( arg_pos >= argc ) {
            print_usage();
            return -1;
        }
        strncpy( m_ctrl.mfile, argv[arg_pos]
                , sizeof( m_ctrl.mfile ) - 4 );
        strcpy( m_ctrl.ofile, m_ctrl.mfile );

        switch( m_ctrl.device ) {
        case 'l':   strcat( m_ctrl.ofile, ".ls" );  break;
		case 'c':	strcat( m_ctrl.ofile, ".pt" );	break;
         	case 'i':       strcat( m_ctrl.ofile, ".i" ); break;
        default:    strcat( m_ctrl.ofile, ".ps" );  break;
        }
        return 0;
}

static print_usage()
{
    printf( "Usage: g_out [-clivfwtm] [frame_y,frame_x]" );
    printf( " [width] [mag] metafile_name\n" );
    return 0;
}

static read_frame_no( str )
char    *str;
{
    if( sscanf( str, "%d,%d"
        , &m_ctrl.frame[0], &m_ctrl.frame[1] ) == 2 ) {
        if( m_ctrl.frame[0] > 0 && m_ctrl.frame[1] > 0 ) {
            if( m_ctrl.frame[0] * m_ctrl.frame[1] <= MXFRAME )
                return  0;
            else
				return -1;
		} else
			return -1;
    } else
        return -1;
}

static read_width( str )
char    *str;
{
    if( sscanf( str, "%d", &m_ctrl.width ) == 1 ) {
        if( m_ctrl.width == 0 )
            m_ctrl.width    = 1;
        else if( m_ctrl.width > 4 )
            m_ctrl.width    = 4;
        return  0;
    } else
        return -1;
}

static read_mag( str )
char    *str;
{
    if( sscanf( str, "%f", &m_ctrl.mag ) == 1 ) {
        if( m_ctrl.mag > 0.0 && m_ctrl.mag <= MXMAG )
            return  0;
		else
			return -1;
    } else
            return -1;
}

/* =============================================================================== */
do_tran( xy )
float   (*xy)[2];
{
    double  temp;

    temp     = (*xy)[0] * mat[0][0] + (*xy)[1] * mat[0][1] + mat[2][0];
    (*xy)[1] = (*xy)[0] * mat[1][0] + (*xy)[1] * mat[1][1] + mat[2][1];
    (*xy)[0] = temp;
    return 0;
}
