
static char rcsid[] = "$Id: lipscom.c,v 1.1 1992/12/14 06:01:39 nakano Exp nakano $";

#include    "g_out.h"

extern M_CTRL      m_ctrl;
extern float       mat[3][2];
static M_attr      attr;
#define     tranp   -1
static int current_no, retc;
static int n_frames, first_frame;
static int PAPER_SIZE_X = 2624;
static int PAPER_SIZE_Y = 1824;
static int orig[MXFRAME][2];
static int ltype[]     = {  0, -2, -1,  1,  2,  3,  4,  0 };
static int mtype[]     = {  4, -4, -2,  0,  2,  3, -1, -3,  1 };
static int acolor[]    = {  1,  2, -3, -1, -8, -4, -5, -9 };
static int lwidth[]    = { -1, -2, -3, -4 };

static frame_orig();
static wrt_frame();
static get_mat();
static wrt_fig();
static lbp_fig();
static put_cl();
static put_pl();
static put_pg();
static put_mk();
static put_tx();

/* ================================================================================ */
lips_form()
{
    int     name_len, mx, my;

    mx = PAPER_SIZE_X + m_ctrl.width * 2;
    my = PAPER_SIZE_Y + m_ctrl.width * 2;

    attr.lw = attr.clw =  1;
    attr.lt = attr.clt =  0;
    attr.ms = attr.cms =  3.0;
    attr.mt = attr.cmt =  0;
    attr.ac = attr.cac =  tranp;

    name_len    = strlen( m_ctrl.ofile );
    (void) lips_init( m_ctrl.ofile, name_len );
    (void) lips_clip( 0, 0, mx, my );
    frame_orig();
    n_frames = m_ctrl.frame[0] * m_ctrl.frame[1];
    first_frame = TRUE;
    while( 1 ) {
        for( current_no = 0; current_no < n_frames; current_no++ ) {
            get_mat();
            retc = wrt_fig();
            if( retc == EOF ) break;
        }
        wrt_frame();
        if( retc != EOF ) {
            (void) lips_formfeed();
        } else {
            (void) lips_terminate();
            break;
        }
    }
}

/* =============================================================================== */
static frame_orig()
{
    int     n, tate, yoko, ix, iy;
    float   xoff, yoff;

    n = 0;
    if( m_ctrl.vflag ) {                      /* paper tate-oki */
        tate = m_ctrl.frame[1];
        yoko = m_ctrl.frame[0];

        xoff = PAPER_SIZE_X / yoko;
        yoff = PAPER_SIZE_Y / tate;
                                                   /* tate-wari */
        if( m_ctrl.tflow ) {
             for( iy = tate; iy > 0; iy-- ) {
                for( ix = yoko; ix > 0; ix-- ) {
                    orig[n][0] = ix * xoff + m_ctrl.width;
                    orig[n][1] = iy * yoff + m_ctrl.width;
                    n++;
                }
            }
        } else {                                   /* yoko-wari */
            for( ix = yoko; ix > 0; ix-- ) {
                for( iy = tate; iy > 0; iy-- ) {
                    orig[n][0] = ix * xoff + m_ctrl.width;
                    orig[n][1] = iy * yoff + m_ctrl.width;
                    n++;
                }
            }
        }
    } else {                                  /* paper yoko-oki */
        tate = m_ctrl.frame[0];
        yoko = m_ctrl.frame[1];

        xoff = PAPER_SIZE_X / yoko;
        yoff = PAPER_SIZE_Y / tate;
                                                   /* tate-wari */
        if( m_ctrl.tflow ) {
            for( ix = 0; ix < yoko; ix++ ) {
                for( iy = tate; iy > 0; iy-- ) {
                    orig[n][0] = ix * xoff + m_ctrl.width;
                    orig[n][1] = iy * yoff + m_ctrl.width;
                    n++;
                }
            }
        } else {                                   /* yoko-wari */
            for( iy = tate; iy > 0; iy-- ) {
                for( ix = 0; ix < yoko; ix++ ) {
                    orig[n][0] = ix * xoff + m_ctrl.width;
                    orig[n][1] = iy * yoff + m_ctrl.width;
                    n++;
                }
            }
        }
    }
}

/* =============================================================================== */
static wrt_frame()
{
    int     pn, p[MXPOLYLINE][2], i, y, x;
    int     tate, yoko, tatepitch, yokopitch;

    /* frame_line_width set */
    if( m_ctrl.width < 0 ) {
            return 0;
    } else if( attr.clw != m_ctrl.width ) {
        if( m_ctrl.width > 0 && m_ctrl.width <= 4 ) {
            lips_line_width( lwidth[m_ctrl.width-1] );
            attr.clw = m_ctrl.width;
        } else {
            lips_line_width( -1 );
            attr.clw = 1;
        }
    }
    /* set frame_line_type */
    if( attr.clt != 0 ) {
        lips_line_type( 0 );
        attr.clt = 0;
    }

    if( m_ctrl.vflag ) {
        tate = m_ctrl.frame[1];
        yoko = m_ctrl.frame[0];
    } else {
        tate = m_ctrl.frame[0];
        yoko = m_ctrl.frame[1];
    }
    tatepitch   = PAPER_SIZE_Y/tate;
    yokopitch   = PAPER_SIZE_X/yoko;

    /* draw tate line */
    pn = 2;
    p[0][1] = m_ctrl.width; 
    p[1][1] = PAPER_SIZE_Y + m_ctrl.width;

    for( i = 0; i <= yoko; i++ ) {
        x   = yokopitch * i + m_ctrl.width;
        p[0][0] = p[1][0] = x;
        lips_polyline( pn, p );
    }

    /* draw yoko line */
    p[0][0] = m_ctrl.width;
    p[1][0] = PAPER_SIZE_X + m_ctrl.width;

    for( i = 0; i <= tate; i++ ) {
        y   = tatepitch * i + m_ctrl.width;
        p[0][1] = p[1][1] = y;
        lips_polyline( pn, p );
    }
	return 0;
}

/* =============================================================================== */
static get_mat()
{
    int     i, j;
    float   temp;

    for( i = 0; i < 3; i++ ) {
        for( j = 0; j < 2; j++ ) {
            if( i == j )    mat[i][j] = 1.0;
            else            mat[i][j] = 0.0;
        }
    }
    /* rotation */
    if( m_ctrl.vflag ) {
        for( i = 0; i < 3; i++ ) {
            temp      = -mat[i][1];
            mat[i][1] =  mat[i][0];
            mat[i][0] =  temp;
        }
    }

    /* map to laser-shot-coord */
    for( i = 0; i < 3; i++ ) {
        mat[i][0] =  mat[i][0] * DOTSPERMM * m_ctrl.mag;
        mat[i][1] = -mat[i][1] * DOTSPERMM * m_ctrl.mag;
    }

    /*  translate to frame origin   */
    mat[2][0] = mat[2][0] + orig[current_no][0];
    mat[2][1] = mat[2][1] + orig[current_no][1];
}

/* =============================================================================== */
static wrt_fig()
{
    retc = lbp_fig();
    return retc;
}

/* =============================================================================== */
static lbp_fig()
{
    int    code;

    while ( ( code = m_inq_code() ) != EOF ) {
        switch ( code ) {
            case  CIRCLE_CODE   : put_cl() ; break;
            case  POLYLINE_CODE : put_pl() ; break;
            case  POLYGON_CODE  : put_pg() ; break;
            case  MARKER_CODE   : put_mk() ; break;
            case  TEXT_CODE     : put_tx() ; break;
            case  LINE_WIDTH_CODE   : m_inq_line_width( &attr.lw )   ; break;
            case  LINE_TYPE_CODE    : m_inq_line_type( &attr.lt )    ; break;
            case  LINE_COLOR_CODE   : m_inq_line_color( &attr.lc )   ; break;
            case  MARKER_SIZE_CODE  : m_inq_marker_size( &attr.ms )  ; break;
            case  MARKER_TYPE_CODE  : m_inq_marker_type( &attr.mt )  ; break;
            case  MARKER_COLOR_CODE : m_inq_marker_color( &attr.mc ) ; break;
            case  AREA_COLOR_CODE   : m_inq_area_color( &attr.ac )   ; break;
            case  TEXT_COLOR_CODE   : m_inq_text_color( &attr.tc )   ; break;
            case  CLS_CODE          : if( first_frame )
                                            first_frame = FALSE;
                                      else
                                            return 0;
            default : ; break;
        }
    }
    return EOF;
}

/* ------------------------------------------------------------------------------- */
static put_cl()
{
    int   fill;
    float  center[2], r;
    int    ix, iy, ir;

    retc = m_inq_circle( &center[0], &center[1], &r, &fill );
    if( retc != 0 ) return retc;

    do_tran( center );

    ix = (int)center[0];
    iy = (int)center[1];
    ir = (int)r * DOTSPERMM * m_ctrl.mag;

    if( fill ) {                                    /* fill pattern set */
        if( attr.ac != attr.cac ) {
            if( attr.ac < 0 || attr.ac > 7 ) {
                lips_set_fptn( -9 );
                attr.cac = 7;
            } else {
                lips_set_fptn( acolor[ attr.ac ] );
                attr.cac = attr.ac;
            }
        } else if( attr.ac == tranp && attr.cac == tranp ) { 
            lips_set_fptn( -9 );
            attr.cac = 7;
        }
    } else {
        if( attr.cac != tranp ) {
            lips_set_fptn( 0 );
            attr.cac = tranp;
        }
    }

    if( attr.lw != attr.clw ) {                     /* line width set */
        if( attr.lw <= 0 ) {
            lips_line_width( -1 );
            attr.clw = 1;
        } else if ( attr.lw > 0 && attr.lw <= 4 ) {
            lips_line_width( lwidth[ attr.lw-1 ] );
            attr.clw = attr.lw;
        } else if ( attr.lw > 4 ) {
            lips_line_width( -4 );
            attr.clw = 4;
        }
    }

    if( attr.lt != attr.clt ) {                     /* line type set */
        if( attr.lt >= 0 && attr.lt <= 7 ) {
            lips_line_type( ltype[ attr.lt ] );
            attr.clt = attr.lt;
        } else  {
            lips_line_type( 0 );
            attr.clt = 0;
        }
    }

    (void) lips_circle( ix, iy, ir );           /* circle data set */
	return 0;
}
/* ------------------------------------------------------------------------------- */
static put_pl()
{
    int     pn;
    float   p[MXPOLYLINE][2];
    int     ip[MXPOLYLINE][2], i;

    retc = m_inq_polyline( &pn, MXPOLYLINE, p );
    if( retc != 0 ) return retc;

    for( i = 0 ; i < pn ; i++ ) {
        do_tran( p[i] );
        ip[i][0] = (int)p[i][0] ;
        ip[i][1] = (int)p[i][1];
    }

    if( attr.lw != attr.clw ) {                     /* line width set */
        if( attr.lw <= 0 ) {
            lips_line_width( -1 );
            attr.clw = 1;
        } else if ( attr.lw > 0 && attr.lw <= 4 ) {
            lips_line_width( lwidth[ attr.lw-1 ] );
            attr.clw = attr.lw;
        } else if ( attr.lw > 4 ) {
            lips_line_width( -4 );
            attr.clw = 4;
        }
    }

    if( attr.lt != attr.clt ) {                     /* line type set */
        if( attr.lt >= 0 && attr.lt <= 7 ) {
            lips_line_type( ltype[ attr.lt ] );
            attr.clt = attr.lt;
        } else  {
            lips_line_type( 0 );
            attr.clt = 0;
        }
    }

    (void) lips_polyline( pn, ip );              /* polyline data set */
	return 0;
}

/* ------------------------------------------------------------------------------- */
static put_pg()
{
    int     pn, fill;
    float   p[MXPOLYGON][2];
    int     ip[MXPOLYGON][2], i;

    retc = m_inq_polygon( &pn, MXPOLYGON, p, &fill );
    if( retc != 0 ) return retc;

    for( i = 0 ; i < pn ; i++ ) {
        do_tran( p[i] );
        ip[i][0] = (int)p[i][0];
        ip[i][1] = (int)p[i][1];
    }

    if( fill ) {                                    /* fill pattern set */
        if( attr.ac != attr.cac ) {
            if( attr.ac < 0 || attr.ac > 7 ) {
                lips_set_fptn( -9 );
                attr.cac = 7;
            } else {
                lips_set_fptn( acolor[ attr.ac ] );
                attr.cac = attr.ac;
            }
        } else if( attr.ac == tranp && attr.cac == tranp ) { 
            lips_set_fptn( -9 );
            attr.cac = 7;
        }
    } else {
        if( attr.cac != tranp ) {
            lips_set_fptn( 0 );
            attr.cac = tranp;
        }
    }

    if( attr.lw != attr.clw ) {                     /* line width set */
        if( attr.lw <= 0 ) {
            lips_line_width( -1 );
            attr.clw = 1;
        } else if ( attr.lw > 0 && attr.lw <= 4 ) {
            lips_line_width( lwidth[ attr.lw-1 ] );
            attr.clw = attr.lw;
        } else if ( attr.lw > 4 ) {
            lips_line_width( -4 );
            attr.clw = 4;
        }
    }

    if( attr.lt != attr.clt ) {                     /* line type set */
        if( attr.lt >= 0 && attr.lt <= 7 ) {
            lips_line_type( ltype[ attr.lt ] );
            attr.clt = attr.lt;
        } else  {
            lips_line_type( 0 );
            attr.clt = 0;
        }
    }

    (void) lips_polygon( pn, ip );                /* polygon data set */
	return 0;
}

/* ------------------------------------------------------------------------------- */
static put_mk()
{
    int     pn, s;
    float   center[2];
    int     ip[2];

    retc = m_inq_marker( &center[0],&center[1] );
    if( retc != 0 ) return retc;

    if( attr.mt != attr.cmt ) {                     /* marker type set */
        if( attr.mt >= -4 && attr.mt <= 4 ) {
            lips_set_marker( mtype[ attr.mt + 4 ] );
            attr.cmt = attr.mt;
        } else {
            lips_set_marker( 2 );
            attr.cmt = 0;
        }
    }

    s = (int)( attr.ms * 3.0 );
    if( attr.ms != attr.cms ) {                     /* marker size set */
        if( attr.ms >= 0.0 && attr.ms < 3.0 ) {
            lips_markersize( 9 );
            attr.cms = 3.0;
        } else if ( attr.ms <= MXMK_SIZE ) {
            lips_markersize( s );
            attr.cms = attr.ms;
        }
    }
    pn = 1;
    do_tran( center );

    ip[0] = (int)center[0];
    ip[1] = (int)center[1];

    (void) lips_polymarker( pn, ip );             /* marker data set */
	return 0;
}

/* ------------------------------------------------------------------------------- */
static put_tx()
{
    float   head[2];
    int     ix, iy;
    char    string[MXTEXTLEN];

    retc = m_inq_text( &head[0], &head[1], string, MXTEXTLEN );
    if( retc != 0 ) return retc;

    do_tran( head );

    ix = (int)head[0];
    iy = (int)head[1];

    (void) lips_text( ix, iy, string );
	return 0;
}
