
static char rcsid[] = "$Id: m_io.c,v 1.3 1995/05/23 07:08:22 nakano Exp nakano $";

#include    "medef.h"
#include    "metag.h"

static FILE        *metafile;
FIGURE      m_fig;
static int         retc, pl_npt = -1;
static float       pl_points[MAX_PLINE][2];

static putbuf();
static dump_polyline();
static int net_point();
static int net_write();

#define module_code PUTBUF_M

static putbuf( buf, len )
char    *buf;
int     len;
/* -------------------------------------------------------- */
/*                       Dec 26th, 1990     Fujio, S.       */
/* -------------------------------------------------------- */
{
    int     i;

    for( i = 0; i < len; i++ ) {
        putc( buf[i], metafile );
    }

    /* adjust to short word boundary */
    if( len % 2 > 0 && putc( '\0', metafile ) == ERROR )
        ERRET( -1 );
    return 0;
}

getbuf( buf, len )
char    *buf;
int     len;
/* -------------------------------------------------------- */
/*                       Dec 26th, 1990     Fujio, S.       */
/*                       May 19th, 1995     Nakano, H.      */
/* -------------------------------------------------------- */
{
    int     c;
    ushort  s;

    while ( len ) {
	if ( len % 2 ) {
	    if( ( c = getc( metafile ) ) == EOF )
		return EOF;
	    *buf++ = c;
	    len --;
	}
	else {
	    if( ( c = getc( metafile ) ) == EOF )
		return EOF;
	    s = (c & 0xff) << 8;
	    if( ( c = getc( metafile ) ) == EOF )
		return EOF;
	    s = (s | (c & 0xff));
	    *(ushort *)buf = s;
	    buf += 2;
	    len -= 2;
	}
    }
    return 0;
}

#undef module_code
#define module_code DUMP_POLYLINE_M

static dump_polyline()
/* -------------------------------------------------------- */
/*                      Jan 19th, 1991      Koganeya, H.    */
/* -------------------------------------------------------- */
{
    int     pl_tmp;

    pl_tmp = pl_npt;
    pl_npt = -1;
    if( pl_tmp > 1 ) {
        retc = m_polyline( pl_tmp, (float(*)[][2])pl_points );
        if( retc != 0 ) ERRET( -2 );
    }
    return 0;
}

#undef module_code
#define module_code OPEN_M

int m_open( fname, mode )
char    *fname, *mode;
/* -------------------------------------------------------- */
/*                      Dec 24th, 1990      Koganeya, H.    */
/*                      May 22th, 1995      Nakano, H.      */
/* -------------------------------------------------------- */
{
#ifdef __STDC__
    time_t  time(), t;
#else
    long    time(), t;
#endif
    char    *cp, hdr_buf[HDR_LEN];

    if( metafile != 0 )
        (void)fclose( metafile );
    if( mode[0] == 'W' || mode[0] == 'w' ) {
        metafile = fopen( fname, "w" );
        if( metafile == 0 ) ERRET( -3 );

        (void)strncpy( hdr_buf, FILE_TITLE, 32 );
        (void)time( &t );
        cp  = asctime( localtime( &t ) );
        *(cp + strlen(cp) - 1) = '\0';
        (void)strncpy( hdr_buf+32, cp, HDR_LEN-32 );
        return putbuf( hdr_buf, HDR_LEN );
    } else if( mode[0] == 'R' || mode[0] == 'r' ) {
        metafile = fopen( fname, "r" );
        if( metafile == 0 ) ERRET( -4 );
        (void)fseek( metafile, (long)HDR_LEN, 0 );
        return 0;
    } else
        ERRET( -5 );
}

int m_cls()
/* -------------------------------------------------------- */
/*                      Dec 24th, 1990      Koganeya, H.    */
/* -------------------------------------------------------- */
{
    retc = dump_polyline();
    if( retc != 0 ) return retc;

    m_fig.HDR.CODE  = CLS_CODE;
    m_fig.HDR.FLAG  = '\0';
    retc =  putbuf( (char*)&m_fig, sizeof( m_fig.HDR ) );
    return retc;
}

#undef module_code
#define module_code CLOSE_M

int m_close()
/* -------------------------------------------------------- */
/*                      Dec 24th, 1990      Koganeya, H.    */
/* -------------------------------------------------------- */
{
    retc = dump_polyline();
    if( retc != 0 ) return retc;

    retc =  fclose( metafile );
    if( retc != 0 )
        ERRET( -6 );
    return 0;
}

#undef module_code
#define module_code LINE_WIDTH_M

int m_line_width( n )
int     n;
/* -------------------------------------------------------- */
/*                      Dec 26th, 1990      Fujio, S.       */
/* -------------------------------------------------------- */
{
    retc = dump_polyline();
    if( retc != 0 ) return retc;

    m_fig.HDR.CODE = LINE_WIDTH_CODE;
    m_fig.HDR.FLAG = '\0';
    m_fig.D.LW = n;

    if( n < 0 ) ERRET( -1 );
    retc = putbuf( (char*)&m_fig
        , sizeof( m_fig.HDR ) + sizeof( m_fig.D.LW ) );
    return retc;
}

int m_line_type( n )
int     n;
/* -------------------------------------------------------- */
/*                      Dec 26th, 1990      Fujio, S.       */
/* -------------------------------------------------------- */
{
    retc = dump_polyline();
    if( retc != 0 ) return retc;

    m_fig.HDR.CODE = LINE_TYPE_CODE;
    m_fig.HDR.FLAG = '\0';
    m_fig.D.LT = n;

    retc = putbuf( (char*)&m_fig
        , sizeof( m_fig.HDR ) + sizeof( m_fig.D.LT ) );
    return retc;
}

int m_line_color( n )
int     n;
/* -------------------------------------------------------- */
/*                      Dec 26th, 1990      Fujio, S.       */
/* -------------------------------------------------------- */
{
    retc = dump_polyline();
    if( retc != 0 ) return retc;

    m_fig.HDR.CODE = LINE_COLOR_CODE;
    m_fig.HDR.FLAG = '\0';
    m_fig.D.LC = n;

    retc = putbuf( (char*)&m_fig
        , sizeof( m_fig.HDR ) + sizeof( m_fig.D.LC ) );
    return retc;
}

#undef module_code
#define module_code MARKER_SIZE_M

int m_marker_size( s )
float   s;
/* -------------------------------------------------------- */
/*                      Dec 26th, 1990      Fujio, S.       */
/* -------------------------------------------------------- */
{
    m_fig.HDR.CODE = MARKER_SIZE_CODE;
    m_fig.HDR.FLAG = '\0';
    m_fig.D.MS = ICORD(s);

    if( s < 0.0 ) ERRET( -2 );

    retc = putbuf( (char*)&m_fig
        , sizeof( m_fig.HDR ) + sizeof( m_fig.D.MS ) );
    return retc;
}

int m_marker_type( n )
int     n;
/* -------------------------------------------------------- */
/*                      Dec 26th, 1990      Fujio, S.       */
/* -------------------------------------------------------- */
{
    m_fig.HDR.CODE = MARKER_TYPE_CODE;
    m_fig.HDR.FLAG = '\0';
    m_fig.D.MT = n;

    retc = putbuf( (char*)&m_fig
        , sizeof( m_fig.HDR ) + sizeof( m_fig.D.MT ) );
    return retc;
}

int m_marker_color( n )
int     n;
/* -------------------------------------------------------- */
/*                      Dec 27th, 1990      Fujio, S.       */
/* -------------------------------------------------------- */
{
    m_fig.HDR.CODE = MARKER_COLOR_CODE;
    m_fig.HDR.FLAG = '\0';
    m_fig.D.MC = n;

    retc = putbuf( (char*)&m_fig
        , sizeof( m_fig.HDR ) + sizeof( m_fig.D.MC ) );
    return retc;
}

int m_area_color( n )
int     n;
/* -------------------------------------------------------- */
/*                      Dec 27th, 1990      Fujio, S.       */
/* -------------------------------------------------------- */
{
    m_fig.HDR.CODE = AREA_COLOR_CODE;
    m_fig.HDR.FLAG = '\0';
    m_fig.D.AC = n;

    retc = putbuf( (char*)&m_fig
        , sizeof( m_fig.HDR ) + sizeof( m_fig.D.AC ) );
    return retc;
}

int m_text_color( n )
int     n;
/* -------------------------------------------------------- */
/*                      Dec 27th, 1990      Fujio, S.       */
/* -------------------------------------------------------- */
{
    m_fig.HDR.CODE = TEXT_COLOR_CODE;
    m_fig.HDR.FLAG = '\0';
    m_fig.D.TC = n;

    retc = putbuf( (char*)&m_fig
        , sizeof( m_fig.HDR ) + sizeof( m_fig.D.TC ) );
    return retc;
}


#undef module_code
#define module_code MOVE_M

m_move( x, y )
float   x, y;
/* -------------------------------------------------------- */
/*                      Jan 19th, 1991      Koganeya, H.    */
/* -------------------------------------------------------- */
{
    retc = dump_polyline();
    if( retc != 0 ) return retc;

    CHK_RANGE( x, -1 );
    CHK_RANGE( y, -1 );
    pl_points[0][0] = x;
    pl_points[0][1] = y;
    pl_npt  = 1;
    return 0;
}

#undef module_code
#define module_code PLOT_M

m_plot( x, y )
float   x, y;
/* -------------------------------------------------------- */
/*                      Jan 19th, 1991      Koganeya, H.    */
/* -------------------------------------------------------- */
{
    if( pl_npt < 0 ||           /* m_move is not called yet or  */
    pl_npt >= MAX_PLINE )   /* point array is full then     */
        ERRET( -2 );

    CHK_RANGE( x, -3 );
    CHK_RANGE( y, -3 );
    pl_points[pl_npt][0] = x;
    pl_points[pl_npt][1] = y;
    pl_npt++;
    return 0;
}

#undef module_code
#define module_code CIRCLE_M

int m_circle( x, y, r, dummy, fill )
float   x, y, r;
int     fill;
int     dummy;  /* reserved for edge option */
/* -------------------------------------------------------- */
/*                      Dec 24th, 1990      Koganeya, H.    */
/* -------------------------------------------------------- */
{
    retc = dump_polyline();
    if( retc != 0 ) return retc;

    CHK_RANGE( x, -4 );
    CHK_RANGE( y, -4 );
    CHK_RANGE( r, -4 );

    m_fig.HDR.CODE  = CIRCLE_CODE;
    m_fig.HDR.FLAG  = fill ? 1 : 0;
    m_fig.D.CC.X    = ICORD(x);
    m_fig.D.CC.Y    = ICORD(y);
    m_fig.D.CC.R    = ICORD(r);

    retc = putbuf ( (char*)&m_fig
        , sizeof( m_fig.HDR ) + sizeof( m_fig.D.CC ) );
    return retc;
}

#undef module_code
#define module_code MARKER_M

int m_marker( x, y )
float   x, y;
/* -------------------------------------------------------- */
/*                       Dec 25th, 1990     Fujio, S.       */
/* -------------------------------------------------------- */
{
    retc = dump_polyline();
    if( retc != 0 ) return retc;

    CHK_RANGE( x, -5 );
    CHK_RANGE( y, -5 );

    m_fig.HDR.CODE = MARKER_CODE;
    m_fig.HDR.FLAG = '\0';
    m_fig.D.MM.X   = ICORD(x);
    m_fig.D.MM.Y   = ICORD(y);

    retc = putbuf( (char*)&m_fig
        , sizeof( m_fig.HDR ) + sizeof( m_fig.D.MM ) );
    return retc;
}

static int
net_point( n, p )
int		n;
float	(*p)[][2];
{
	int		net, i;

	if( n < 1 ) return n;

	net	= 1;
	for( i = 0; i < n-1; i++ ) {
		if( ICORD((*p)[i][0]) != ICORD((*p)[i+1][0]) ||
			ICORD((*p)[i][1]) != ICORD((*p)[i+1][1]) )	net++;
	}
	return net;
}

static int
net_write( net, p, minpoint )
int		net;
float	(*p)[][2];
int		minpoint;
{
	int		i, j;
    ushort  gn[2];
	float	(*w)[2];

	w  = (float(*)[2])&(*p)[0][0];

	for( i = 0; i < net; i++ ) {
        for( j = 0; j < 2; j++ ) {
            CHK_RANGE( (*w)[j], -10 );
            gn[j] = ICORD( (*w)[j] );
        }
        retc = putbuf( (char*)gn, sizeof(ushort)*2 );
        if( retc != 0 ) return retc;
		
		if( i < net-1 ) {
			do {
				w++;
			} while( ICORD( (*w)[0] ) == gn[0]
				&&   ICORD( (*w)[1] ) == gn[1] );
		}
    }
	for( i = net; i < minpoint; i++ ) {	
		retc = putbuf( (char*)gn, sizeof(ushort)*2 );
	}
	return 0;
}

#undef module_code
#define module_code POLYLINE_M

int m_polyline( n, p )
int     n;
float   (*p)[][2];
/* -------------------------------------------------------- */
/*                       Jan 17th, 1991     Fujio, S.       */
/* -------------------------------------------------------- */
{
    int     i, net, minpoint;

    /* dump_polyline(); */
    if( pl_npt > 1 ) {
        i = pl_npt;
        pl_npt  = -1;
        retc = m_polyline( i, (float(*)[][2])pl_points );
        if( retc != 0 ) ERRET( -6 );
    }
	minpoint = 2;	/* minimum point to write to metafile */
    if( n == 0 ) return 0;
    m_fig.HDR.CODE = POLYLINE_CODE;
    m_fig.HDR.FLAG = '\0';
	net	= net_point( n, p );
	m_fig.D.NP = max( net, minpoint );

   	retc = putbuf( (char*)&m_fig
       	 , sizeof( m_fig.HDR ) + sizeof( m_fig.D.NP ) );

	net_write( net, p, minpoint );
    return 0;
}

#undef module_code
#define module_code POLYGON_M

int m_polygon( n, p, fill )
int     n, fill;
float   (*p)[][2];
/* -------------------------------------------------------- */
/*                       Jan 17th, 1991     Fujio, S.       */
/* -------------------------------------------------------- */
{
    int     net, minpoint;

    retc = dump_polyline();
    if( retc != 0 ) return retc;

    if( n == 0 ) return 0;
    if( n == 1 || n == 2 ) ERRET( -9 );

	minpoint = 3;	/* minimum point to write to metafile */
    m_fig.HDR.CODE = POLYGON_CODE;
    m_fig.HDR.FLAG = fill ? 1 : 0;
	net = net_point( n, p ); 
	m_fig.D.GN = max( net, minpoint );

    retc = putbuf( (char*)&m_fig
        , sizeof( m_fig.HDR ) + sizeof( m_fig.D.GN ) );

	net_write( net, p, minpoint );
    return 0;
}

#undef module_code
#define module_code TEXT_M

int m_text ( x, y, string )
float   x, y;
char    *string;
/* -------------------------------------------------------- */
/*                       Dec 26th, 1990     Fujio, S.       */
/* -------------------------------------------------------- */
{
    retc = dump_polyline();
    if( retc != 0 ) return retc;

    if( strlen(string) == 0 ) return 0;

    CHK_RANGE( x, -11);
    CHK_RANGE( y, -11);

    m_fig.HDR.CODE = TEXT_CODE;
    m_fig.HDR.FLAG = '\0';
    m_fig.D.TT.X   = ICORD(x);
    m_fig.D.TT.Y   = ICORD(y);

    retc = putbuf( (char*)&m_fig
        , sizeof( m_fig.HDR ) + sizeof(m_fig.D.TT) );
    if( retc != 0 ) return retc;

    retc = putbuf( string, strlen(string) + 1 );
    if( retc != 0 ) return retc;
    return 0;
}

#undef module_code
#define module_code INQ_CODE_M

int m_inq_code()
/* -------------------------------------------------------- */
/*                      Dec 24th, 1990      Koganeya, H.    */
/*                      May 19th, 1995      Nakano, H.      */
/* -------------------------------------------------------- */
{
    int     c;

    if ( getbuf( (char*)&m_fig.HDR.CODE, sizeof( m_fig.HDR.CODE ) ) )
	return -1;
    if ( getbuf( (char*)&m_fig.HDR.FLAG, sizeof( m_fig.HDR.FLAG ) ) )
	return -1;
    if( m_fig.HDR.CODE == CLS_CODE ) {
        c   = getc( metafile );
        if( c == EOF )  return -1;
        else    ungetc( c, metafile );
    }
    return (int)m_fig.HDR.CODE;
}

#undef module_code
#define module_code INQ_LINE_WIDTH_M

int m_inq_line_width( pn )
int     *pn;
/* -------------------------------------------------------- */
/*                       Dec 27th, 1990     Fujio, S.       */
/* -------------------------------------------------------- */
{
    if( m_fig.HDR.CODE != LINE_WIDTH_CODE ) ERRET( -1 );

    retc = getbuf( (char*)&m_fig.D, sizeof( m_fig.D.LW ) );
    if( retc == 0 ) {
        *pn = m_fig.D.LW;
        return 0;
    } else {
        *pn = -1;
        ERRET( -2 );
    }
}

#undef module_code
#define module_code INQ_LINE_TYPE_M

int m_inq_line_type( pn )
int     *pn;
/* -------------------------------------------------------- */
/*                       Dec 27th, 1990     Fujio, S.       */
/* -------------------------------------------------------- */
{
    if( m_fig.HDR.CODE != LINE_TYPE_CODE ) ERRET( -3 );

    retc = getbuf( (char*)&m_fig.D, sizeof( m_fig.D.LT ) );
    if( retc == 0 ) {
        *pn = m_fig.D.LT;
        return 0;
    } else {
        *pn = -1;
        ERRET( -4 );
    }
}

#undef module_code
#define module_code INQ_LINE_COLOR_M

int m_inq_line_color( pn )
int     *pn;
/* -------------------------------------------------------- */
/*                       Jan  7th, 1991     Fujio, S.       */
/* -------------------------------------------------------- */
{
    if( m_fig.HDR.CODE != LINE_COLOR_CODE ) ERRET( -5 );

    retc = getbuf( (char*)&m_fig.D, sizeof( m_fig.D.LC ) );
    if( retc == 0 ) {
        *pn = m_fig.D.LC;
        return 0;
    } else {
        *pn = -1;
        ERRET( -6 );
    }
}

#undef module_code
#define module_code INQ_MARKER_SIZE_M

int m_inq_marker_size( ps )
float   *ps;
/* -------------------------------------------------------- */
/*                       Jan  7th, 1991     Fujio, S.       */
/* -------------------------------------------------------- */
{
    if( m_fig.HDR.CODE != MARKER_SIZE_CODE ) ERRET( -7 );

    retc = getbuf( (char*)&m_fig.D, sizeof( m_fig.D.MS ) );
    if( retc == 0 ) {
        *ps = FCORD(m_fig.D.MS);
        return 0;
    } else {
        *ps = -1.0;
        ERRET( -8 );
    }
}

#undef module_code
#define module_code INQ_MARKER_TYPE_M

int m_inq_marker_type( pn )
int     *pn;
/* -------------------------------------------------------- */
/*                       Jan  7th, 1991     Fujio, S.       */
/* -------------------------------------------------------- */
{
    if( m_fig.HDR.CODE != MARKER_TYPE_CODE ) ERRET( -9 );

    retc = getbuf( (char*)&m_fig.D, sizeof( m_fig.D.MT ) );
    if( retc == 0 ) {
        *pn = m_fig.D.MT;
        return 0;
    } else {
        *pn = -1;
        ERRET( -10 );
    }
}

#undef module_code
#define module_code INQ_MARKER_COLOR_M

int m_inq_marker_color( pn )
int     *pn;
/* -------------------------------------------------------- */
/*                       Jan  7th, 1991     Fujio, S.       */
/* -------------------------------------------------------- */
{
    if( m_fig.HDR.CODE != MARKER_COLOR_CODE ) ERRET( -11 );

    retc = getbuf( (char*)&m_fig.D, sizeof( m_fig.D.MC ) );
    if( retc == 0 ) {
        *pn = m_fig.D.MC;
        return 0;
    } else {
        *pn = -1;
        ERRET( -12 );
    }
}

#undef module_code
#define module_code INQ_AREA_COLOR_M

int m_inq_area_color( pn )
int     *pn;
/* -------------------------------------------------------- */
/*                       Jan  7th, 1991     Fujio, S.       */
/* -------------------------------------------------------- */
{
    if( m_fig.HDR.CODE != AREA_COLOR_CODE ) ERRET( -13 );

    retc = getbuf( (char*)&m_fig.D, sizeof( m_fig.D.AC ) );
    if( retc == 0 ) {
        *pn = m_fig.D.AC;
        return 0;
    } else {
        *pn = -1;
        ERRET( -14 );
    }
}

#undef module_code
#define module_code INQ_TEXT_COLOR_M

int m_inq_text_color( pn )
int     *pn;
/* -------------------------------------------------------- */
/*                       Jan  7th, 1991     Fujio, S.       */
/* -------------------------------------------------------- */
{
    if( m_fig.HDR.CODE != TEXT_COLOR_CODE ) ERRET( -15 );

    retc = getbuf( (char*)&m_fig.D, sizeof( m_fig.D.TC ) );
    if( retc == 0 ) {
        *pn = m_fig.D.TC;
        return 0;
    } else {
        *pn = -1;
        ERRET( -16 );
    }
}

#undef module_code
#define module_code INQ_CIRCLE_M

int m_inq_circle( px, py, pr, pfill )
float   *px, *py, *pr;
int     *pfill;
/* -------------------------------------------------------- */
/*                      Dec 24th, 1990      Koganeya, H.    */
/* -------------------------------------------------------- */
{
    if( m_fig.HDR.CODE != CIRCLE_CODE ) ERRET( -1 );

    retc = getbuf( (char*)&m_fig.D, sizeof( m_fig.D.CC ) );
    if( retc == 0 ) {
        *pfill  = m_fig.HDR.FLAG;
        *px     = FCORD(m_fig.D.CC.X);
        *py     = FCORD(m_fig.D.CC.Y);
        *pr     = FCORD(m_fig.D.CC.R);
        return 0;
    } else {
        *pfill  = 0;
        *px     = 0.0;
        *py     = 0.0;
        *pr     = 0.0;
        ERRET( -2 );
    }
}

#undef module_code
#define module_code INQ_MARKER_M

int m_inq_marker( px, py )
float   *px, *py;
/* -------------------------------------------------------- */
/*                       Dec 25th, 1990     Fujio, S.       */
/* -------------------------------------------------------- */
{
    if( m_fig.HDR.CODE != MARKER_CODE ) ERRET( -3 );

    retc = getbuf( (char*)&m_fig.D, sizeof( m_fig.D.MM ) );
    if( retc == 0 ) {
        *px   = FCORD(m_fig.D.MM.X);
        *py   = FCORD(m_fig.D.MM.Y);
        return 0;
    } else {
        *px   = 0.0;
        *py   = 0.0;
        ERRET( -4 );
    }
}

#undef module_code
#define module_code INQ_POLYLINE_M

int m_inq_polyline( pn, limit, p )
int     *pn, limit;
float   (*p)[][2];
/* -------------------------------------------------------- */
/*                       Jan 17th, 1991     Fujio, S.       */
/* -------------------------------------------------------- */
{
    int     nset, skip;
    ushort  work[2];

    if( m_fig.HDR.CODE != POLYLINE_CODE )  ERRET( -5 );

    retc = getbuf( (char*)&m_fig.D, sizeof( m_fig.D.NP ) );
    if( retc != 0 ) ERRET( -6 );

    *pn     = m_fig.D.NP;
    skip    = FALSE;
    for( nset = 0; nset < *pn; nset++ ) {
        retc = getbuf( (char*)work, sizeof( work ) );
        if( retc != 0 ) ERRET( -7 );

        if( nset <= limit ) {
            (*p)[nset][0]   = FCORD( work[0] );
            (*p)[nset][1]   = FCORD( work[1] );
        } else {
            skip    = TRUE;
        }
    }
    return( skip ? 1 : 0 );
}

#undef module_code
#define module_code INQ_POLYGON_M

int m_inq_polygon( pn, limit, p, pfill )
int     *pn, limit, *pfill;
float   (*p)[][2];
/* -------------------------------------------------------- */
/*                       Jan 23th, 1991     Fujio, S.       */
/* -------------------------------------------------------- */
{
    int     nset, skip;
    ushort  work[2];

    if( m_fig.HDR.CODE != POLYGON_CODE )  ERRET( -8 );

    retc = getbuf( (char*)&m_fig.D, sizeof( m_fig.D.GN ) );
    if( retc != 0 ) ERRET( -9 );

    *pfill  = m_fig.HDR.FLAG;
    *pn     = m_fig.D.GN;
    skip    = FALSE;
    for( nset = 0; nset < *pn; nset++ ) {
        retc = getbuf( (char*)work, sizeof( work ) );
        if( retc != 0 ) ERRET( -10 );

        if( nset <= limit ) {
            (*p)[nset][0]   = FCORD( work[0] );
            (*p)[nset][1]   = FCORD( work[1] );
        } else {
            skip    = TRUE;
        }
    }
    return( skip ? 1 : 0 );
}

#undef module_code
#define module_code INQ_TEXT_M

int m_inq_text( px, py, string, buflen )
float   *px, *py;
char    *string;
int     buflen;
/* -------------------------------------------------------- */
/*                       Jan 10th, 1991     Fujio, S.       */
/*                       May 19th, 1995     Nakano, H.      */
/* -------------------------------------------------------- */
{
    int     skip;
    char    *pc, *lmt, work[2];

    if( m_fig.HDR.CODE != TEXT_CODE ) ERRET( -11 );

    /* report its position */
    retc = getbuf( (char*)&m_fig.D, sizeof( m_fig.D.TT ) );
    if( retc != 0 ) {
        *px   = 0.0;
        *py   = 0.0;
        ERRET( -12 );
    }
    *px   = FCORD( m_fig.D.TT.X );
    *py   = FCORD( m_fig.D.TT.Y );

    /* set its contents */
    pc      = string;
    lmt     = pc + buflen - 1;
    skip    = FALSE;
    while( 1 ) {
        if( ( retc = getbuf( &work[0], 1 ) ) != 0 )
            ERRET( -13 );
        if( ( retc = getbuf( &work[1], 1 ) ) != 0 )
            ERRET( -13 );
        if( pc < lmt ) {
            (void)strncpy( pc, work, 2 );
            pc  += 2;
        } else {
            skip    = TRUE;
        }
        if( work[0] == '\0' || work[1] == '\0' ) break;
    }
    return( skip ? 1 : 0 );
}

