
/*
 *	$Id: g_bird.h,v 1.1 1992/12/14 06:01:16 nakano Exp nakano $
 */

extern double	sin G_ARGS ((double x));
extern double	cos G_ARGS ((double x));
extern double	fabs G_ARGS ((double x));

#define	PI			(3.141592653589793238)
#define SET(p, xx, yy, zz)	((p).x = (xx), (p).y = (yy), (p).z = (zz))
#define SET2D(p, xx, yy)	((p).x = (xx), (p).y = (yy))

#define PZ(z, z_level, z_scale)	((z_scale) * ((z) - (z_level)))

#define ROT(st, ct, sp, cp, x, y, z) \
{ \
    G_POS	tmp_y = - (st) * (x) + (ct) * (y); \
 \
    (x) = (ct) * (x) + (st) * (y); \
    (y) = (cp) * tmp_y - (sp) * (z); \
    (z) = (sp) * tmp_y + (cp) * (z); \
}

#define PROJ(d, x, y, z, result_x, result_y) \
{ \
    if ((d) <= 0.0) \
    { \
	(result_x) = (x); \
	(result_y) = (z); \
    } \
    else \
    { \
	(result_x) = (x) / ((d) + (y)); \
	(result_y) = (z) / ((d) + (y)); \
    } \
}

#define GET_XY(st, ct, sp, cp, d, x, y, z, result_x, result_y) \
{ \
	G_POS	tmp_xx = (x); \
	G_POS	tmp_yy = (y); \
	G_POS	tmp_zz = (z); \
 \
	ROT (st, ct, sp, cp, tmp_xx, tmp_yy, tmp_zz); \
	PROJ (distance, tmp_xx, tmp_yy, tmp_zz, result_x, result_y); \
}

#define FAKE_X(x, y, z, y_to_x, y_to_y)	((x) + (y) * (y_to_x))
#define FAKE_Y(x, y, z, y_to_x, y_to_y)	((z) + (y) * (y_to_y))

typedef struct
{
    G_POS	x;
    G_POS	y;
    G_POS	z;
}
G_POINT_3D;

#define AXIS_LINE()		(g_set_line (G_BLACK, 1, G_LINE_SOLID))
#define EDGE_LINE()		(g_set_line (G_BLACK, 1, G_LINE_SOLID))
#define ROOF_LINE()		(g_set_line (G_BLACK, 1, G_LINE_SOLID))
#define SIDE_LINE()		(g_set_line (G_BLACK, 1, G_LINE_SOLID))

#define SIDE_AREA()		(g_set_area (G_WHITE))
#define ROOF_AREA()		(g_set_area (G_WHITE))

#define SET_BW_COLOR()	(g_set_bw_color ((unsigned long) (1 << G_BLACK)))

extern G_BOOL	g_start_bird G_ARGS
		    ((G_P_DIM x_wid, G_P_DIM y_wid, G_P_DIM z_wid,
		      G_P_REAL z_bottom, G_P_REAL z_top,
		      G_P_DIM distance, G_P_REAL theta, G_P_REAL phi,
		      G_P_POS x_left_std, G_P_POS y_top_std,
		      G_P_DIM x_wid_std, G_P_DIM y_wid_std,
		      G_P_REAL * sth, G_P_REAL * cth,
		      G_P_REAL * sphi, G_P_REAL * cphi,
		      int * last_axis, G_P_POS * z_level, G_P_REAL * z_scale,
		      char * proc));

extern void	g_end_bird G_ARGS ((void));

extern G_BOOL	g_start_fake_bird G_ARGS
		    ((G_P_REAL z_bottom, G_P_REAL z_top,
		      G_P_REAL x_ratio, G_P_REAL y_ratio,
		      G_P_POS x_left_std, G_P_POS y_top_std,
		      G_P_DIM x_wid_std, G_P_DIM y_wid_std,
		      G_P_REAL * y_to_x, G_P_REAL * y_to_y,
		      char * proc));

extern void	g_end_fake_bird G_ARGS ((void));


