
static char rcsid[] = "$Id: g_bird_view.c,v 1.4 1995/05/23 05:26:00 nakano Exp nakano $";

#include "g_private.h"
#include "g_bird.h"

static void
do_bird_view (x_wid, y_wid, z_wid, z_bottom, z_top, distance, theta, phi,
	      x_left_std, y_top_std, x_wid_std, y_wid_std,
	      data, n_x, n_y, unit_x, unit_y,
	      direction)
    G_P_DIM	x_wid, y_wid, z_wid;
    G_P_REAL	z_bottom, z_top;
    G_P_DIM	distance;
    G_P_REAL	theta, phi;
    G_P_POS	x_left_std, y_top_std;
    G_P_DIM	x_wid_std, y_wid_std;
    G_REAL *	data;
    int		n_x, n_y, unit_x, unit_y, direction;
{
    G_P_POS	x, y, x_start, y_start, dx, dy;
    G_P_REAL	z_scale;
    G_P_POS	z_level;
    G_P_REAL	sth, cth, sphi, cphi;
    int		last_axis, i, j, k, l;
    G_POS	gx[G_MAX_N_POINTS], gy[G_MAX_N_POINTS];

    g_check_init ();

    if (G_MAX_N_POINTS < n_x || G_MAX_N_POINTS < n_y)
    {
	g_warning ("g_bird_view", "too large data ignored");
	return;
    }

    if (g_start_bird (x_wid, y_wid, z_wid, z_bottom, z_top,
		      distance, theta, phi,
		      x_left_std, y_top_std, x_wid_std, y_wid_std,
		      & sth, & cth, & sphi, & cphi, & last_axis,
		      & z_level, & z_scale, "g_bird_view"))
    {
	return;
    }

    x_start = - x_wid / 2.0, y_start = - y_wid / 2.0;
    dx = x_wid / (n_x - 1), dy = y_wid / (n_y - 1);

    if (direction < 0)
    {
	dy *= -1.0;
	y_start *= -1.0;
    }

    x = x_start, y = y_start;
    l = 0;

    for (j = 0; j < n_y; j ++)
    {
	GET_XY (sth, cth, sphi, cphi, distance,
		x, y, PZ (data[l], z_level, z_scale), gx[j], gy[j]);
	l += unit_y;
	y += dy;
    }

    SIDE_LINE ();
    Cg_polyline (gx, gy, n_y);

    ROOF_LINE ();
    y = y_start;
    k = 0;

    for (i = 0; i < n_y; i ++)
    {
	l = k;
	x = x_start;
	for (j = 0; j < n_x; j ++)
	{
	    GET_XY (sth, cth, sphi, cphi, distance,
		    x, y, PZ (data[l], z_level, z_scale), gx[j], gy[j]);
	    l += unit_x;
	    x += dx;
	}
	Cg_polyline (gx, gy, n_x);
	k += unit_y;
	y += dy;
    }

    x = x_start + dx * (n_x - 1);
    y = y_start;
    l = unit_x * (n_x - 1);

    for (j = 0; j < n_y; j ++)
    {
	GET_XY (sth, cth, sphi, cphi, distance,
		x, y, PZ (data[l], z_level, z_scale), gx[j], gy[j]);
	l += unit_y;
	y += dy;
    }

    SIDE_LINE ();
    Cg_polyline (gx, gy, n_y);

    g_end_bird ();
}

void
Cg_bird_view (x_wid, y_wid, z_wid, z_bottom, z_top,
	     distance, theta, phi,
	     x_left_std, y_top_std, x_wid_std, y_wid_std,
	     data, n_x, n_y, direction)
    G_P_DIM	x_wid, y_wid, z_wid;
    G_P_REAL	z_bottom, z_top;
    G_P_DIM	distance;
    G_P_REAL	theta, phi;
    G_P_POS	x_left_std, y_top_std;
    G_P_DIM	x_wid_std, y_wid_std;
    G_REAL *	data;
    int		n_x, n_y, direction;
{
    do_bird_view (x_wid, y_wid, z_wid, z_bottom, z_top,
		  distance, theta, phi,
		  x_left_std, y_top_std, x_wid_std, y_wid_std,
		  data, n_x, n_y, n_y, 1,
		  direction);
}

void
F77g_bird_view (x_wid, y_wid, z_wid, z_bottom, z_top,
	      distance, theta, phi,
	      x_left_std, y_top_std, x_wid_std, y_wid_std,
	      data, n_x, n_y, direction)
    G_DIM	*x_wid, *y_wid, *z_wid;
    G_REAL	*z_bottom, *z_top;
    G_DIM	*distance;
    G_REAL	*theta, *phi;
    G_POS	*x_left_std, *y_top_std;
    G_DIM	*x_wid_std, *y_wid_std;
    G_REAL	*data;
    int		*n_x, *n_y, *direction;
{
    do_bird_view (*x_wid, *y_wid, *z_wid, *z_bottom, *z_top,
		  *distance, *theta, *phi,
		  *x_left_std, *y_top_std, *x_wid_std, *y_wid_std,
		  data, *n_x, *n_y, 1, *n_x,
		  *direction);
}

void
g_bird_view__ (x_wid, y_wid, z_wid, z_bottom, z_top,
	      distance, theta, phi,
	      x_left_std, y_top_std, x_wid_std, y_wid_std,
	      data, n_x, n_y, direction)
    G_DIM	*x_wid, *y_wid, *z_wid;
    G_REAL	*z_bottom, *z_top;
    G_DIM	*distance;
    G_REAL	*theta, *phi;
    G_POS	*x_left_std, *y_top_std;
    G_DIM	*x_wid_std, *y_wid_std;
    G_REAL	*data;
    int		*n_x, *n_y, *direction;
{
    do_bird_view (*x_wid, *y_wid, *z_wid, *z_bottom, *z_top,
		  *distance, *theta, *phi,
		  *x_left_std, *y_top_std, *x_wid_std, *y_wid_std,
		  data, *n_x, *n_y, 1, *n_x,
		  *direction);
}
