
static char rcsid[] = "$Id: g_contln.c,v 1.4 1995/05/23 05:26:03 nakano Exp nakano $";

#include "g_private.h"

#define	INTP(p0, p1, u0, u1)	(((u1) * (p0) - (u0) * (p1)) / ((u1) - (u0)))

static void
cell (xl, xr, yb, yt, u0, u1, u2, u3, h)
    G_P_POS	xl, xr, yb, yt;
    G_P_POS	u0, u1, u2, u3;
    G_P_POS	h;
{
    u0 -= h; u1 -= h; u2 -= h; u3 -= h;

    if (u0 >= 0.0)
    {
	if (u1 < 0.0)
	{
	    Cg_move (INTP (xl, xr, u0, u1), yb);
	    if (u2 < 0.0)
	    {
		Cg_plot (xl, INTP (yb, yt, u0, u2));
		if (u3 >= 0.0)
		{
		    Cg_move (xr, INTP (yb, yt, u1, u3));
		    Cg_plot (INTP (xl, xr, u2, u3), yt);
		}
	    }
	    else
	    {
		if (u3 >= 0.0)
		    Cg_plot (xr, INTP (yb, yt, u1, u3));
		else
		    Cg_plot (INTP (xl, xr, u2, u3), yt);
	    }
	}
	else
	{
	    if (u2 < 0.0)
	    {
		Cg_move (xl, INTP (yb, yt, u0, u2));
		if (u3 >= 0.0)
		    Cg_plot (INTP (xl, xr, u2, u3), yt);
		else
		    Cg_plot (xr, INTP (yb, yt, u1, u3));
	    }
	    else
	    {
		if (u3 < 0.0)
		{
		    Cg_move (xr, INTP (yb, yt, u1, u3));
		    Cg_plot (INTP (xl, xr, u2, u3), yt);
		}
	    }
	}
    }
    else
    {
	if (u1 >= 0.0)
	{
	    Cg_move (INTP (xl, xr, u0, u1), yb);
	    if (u2 >= 0.0)
	    {
		Cg_plot (xl, INTP (yb, yt, u0, u2));
		if (u3 < 0.0)
		{
		    Cg_move (xr, INTP (yb, yt, u1, u3));
		    Cg_plot (INTP (xl, xr, u2, u3), yt);
		}
	    }
	    else
	    {
		if (u3 < 0.0)
		    Cg_plot (xr, INTP (yb, yt, u1, u3));
		else
		    Cg_plot (INTP (xl, xr, u2, u3), yt);
	    }
	}
	else
	{
	    if (u2 >= 0.0)
	    {
		Cg_move (xl, INTP (yb, yt, u0, u2));
		if (u3 < 0.0)
		    Cg_plot (INTP (xl, xr, u2, u3), yt);
		else
		    Cg_plot (xr, INTP (yb, yt, u1, u3));
	    }
	    else
	    {
		if (u3 >= 0.0)
		{
		    Cg_move (xr, INTP (yb, yt, u1, u3));
		    Cg_plot (INTP (xl, xr, u2, u3), yt);
		}
	    }
	}
    }
}

static void
do_contln (x_left, x_right, y_bottom, y_top,
			    data, nx, ny, height, unit_x, unit_y)
    G_P_POS	x_left;
    G_P_POS	x_right;
    G_P_POS	y_bottom;
    G_P_POS	y_top;
    G_REAL *	data;
    int		nx;
    int		ny;
    G_P_POS	height;
    int		unit_x;
    int		unit_y;
{
    int		i, j, k, l;
    G_P_POS	x, y, dx, dy;
    G_POINT	saved_point;

    g_check_init ();

    nx --; ny --;

    if (nx < 1 || ny < 1)
    {
	g_warning ("g_contln", "invalid data size");
	return;
    }

    dx = (x_right - x_left) / nx;
    dy = (y_top - y_bottom) / ny;

    if (dx == 0.0 || dy == 0.0)
    {
	g_warning ("g_contln", "too small area");
	return;
    }

    saved_point = g_context.point;
    y = y_bottom;
    k = 0;

    for (j = 0; j < ny; j ++)
    {
	x = x_left;
	l = k;

	for (i = 0; i < nx; i ++)
	{
	    cell (x, x + dx, y, y + dy, data[l], data[l + unit_x], 
		  data[l + unit_y], data[l + unit_x + unit_y], height);
	    x += dx;
	    l += unit_x;
	}

	y += dy;
	k += unit_y; 
    }	

    g_context.point = saved_point;
}

void
Cg_contln (x_left, x_right, y_bottom, y_top, data, nx, ny, height)
    G_P_POS	x_left;
    G_P_POS	x_right;
    G_P_POS	y_bottom;
    G_P_POS	y_top;
    G_REAL *	data;
    int		nx;
    int		ny;
    G_P_POS	height;
{
    do_contln (x_left, x_right, y_bottom, y_top,
	       data, nx, ny, height, ny, 1);
}

void
F77g_contln (x_left, x_right, y_bottom, y_top, data, nx, ny, height)
    G_POS *	x_left;
    G_POS *	x_right;
    G_POS *	y_bottom;
    G_POS *	y_top;
    G_REAL *	data;
    int *	nx;
    int *	ny;
    G_POS *	height;
{
    do_contln (* x_left, * x_right, * y_bottom, * y_top,
	       data, * nx, * ny, * height, 1, * nx);
}

void
g_contln__ (x_left, x_right, y_bottom, y_top, data, nx, ny, height)
    G_POS *	x_left;
    G_POS *	x_right;
    G_POS *	y_bottom;
    G_POS *	y_top;
    G_REAL *	data;
    int *	nx;
    int *	ny;
    G_POS *	height;
{
    do_contln (* x_left, * x_right, * y_bottom, * y_top,
	       data, * nx, * ny, * height, 1, * nx);
}

