
/*
 *	$Id: g_dev_m.h,v 1.1 1992/12/14 06:01:16 nakano Exp nakano $
 */

#define M_FILE_TITLE		"GRAPHIC METAFILE Rel 0.0"
#define M_FILE_TITLE_LEN	(32)
#define M_FILE_TIME_LEN		(32)

#define M_LINE_WIDTH		(0x20)
#define M_LINE_TYPE		(0x21)
#define M_LINE_COLOR		(0x22)
#define M_MARKER_SIZE		(0x23)
#define M_MARKER_TYPE		(0x24)
#define M_MARKER_COLOR		(0x25)
#define M_AREA_COLOR		(0x26)
#define M_TEXT_COLOR		(0x27)
#define M_CIRCLE		(0x40)
#define M_MARKER		(0x41)
#define M_POLYLINE		(0x42)
#define M_POLYGON		(0x43)
#define M_TEXT			(0x44)
#define M_CLS			(0x80)

#define M_PUT_BYTE(fp, data)		(putc (data, fp))

#define M_PUT_BYTE_2(fp, data) \
	(putc ((data) >> 8, fp), putc ((data) & 0xff, fp))

#define M_PUT_HEADER(fp, type, flag) \
	(M_PUT_BYTE (fp, type), M_PUT_BYTE (fp, flag))

#define M_PUT_COUNT(fp, n)		(M_PUT_BYTE_2 (fp, n))
#define M_PUT_CHAR(fp, c)		(M_PUT_BYTE (fp, c))
#define M_PUT_COLOR(fp, color)		(M_PUT_BYTE_2 (fp, color))
#define M_PUT_LINE_TYPE(fp, type)	(M_PUT_BYTE_2 (fp, type))
#define M_PUT_LINE_WIDTH(fp, width)	(M_PUT_BYTE_2 (fp, width))
#define M_PUT_AREA_COLOR(fp, color)	(M_PUT_BYTE_2 (fp, color))
#define M_PUT_TEXT_FONT(fp, font)	(M_PUT_BYTE_2 (fp, font))

typedef struct
{
    char *		file_name;
    FILE *		fp;
    LINE_PROP		line;
    AREA_PROP		area;
    TEXT_PROP		text;
    G_BOOL		plotted;
    int			n_points;
    G_POINT		points[G_MAX_N_POINTS];
}
M_PRIV;

#define M_TRANSLATE_X(dev, x)	((int) ((x) * 100.0 + 0.5))
#define M_TRANSLATE_Y(dev, y)	((int) ((y) * 100.0 + 0.5))
#define M_TRANSLATE_W(dev, x)	((int) ((x) * 100.0 + 0.5))
#define M_TRANSLATE_H(dev, y)	((int) ((y) * 100.0 + 0.5))

extern DEVICE	g_m_device;

