#include "g_private.h"
#include "g_dev_x.h"
#include <stdio.h>

#define B_TRANSLATE_X(s, x)      (((x) - (s)->x_offset)/((s)->x_scale))
#define B_TRANSLATE_Y(s, y)      (((y) - (s)->y_offset)/((s)->y_scale))

#define B_X_TRANSLATE_X(dev, x)  (((x) - 0.5)/((dev).x_scale))
#define B_X_TRANSLATE_Y(dev, y)  (((y) - 0.5)/((dev).y_scale))

void
Cg_mouse_sence (X, Y, BUTTON)
    G_REAL	*X, *Y;
    int         *BUTTON;
{
    XEvent   event;
    Window   win;
    Display *dpy;
    X_PRIV  *priv = (X_PRIV *)g_x_device.dev_private;
    SCALE   *scale;
    DEVICE   xdevice = g_context.device->slots[1];
    G_REAL   XX, YY;
    int      x, y, button;

    dpy = priv->display;
    win = priv->window;
    
/*
    g_check_init ();
*/

/*
    while (XPending(dpy))
*/
    XSelectInput(dpy, win, ButtonPressMask | ButtonReleaseMask);
    
    while (1)
    {
	XNextEvent(dpy, &event);
	switch(event.type) 
	{
	case ButtonPress:
	    if(event.xbutton.button == 1)
	    {
		x = event.xbutton.x;
		y = event.xbutton.y;
		button = 1;
	    }
	    if(event.xbutton.button == 2)
	    {
		x = event.xbutton.x;
		y = event.xbutton.y;
		button = 2;
	    }
	    if(event.xbutton.button == 3)
	    {
		x = event.xbutton.x;
		y = event.xbutton.y;
		button = 3;
	    }
	    break;
	case ButtonRelease:
	    XX = B_X_TRANSLATE_X(xdevice, x);
	    YY = B_X_TRANSLATE_Y(xdevice, y);

	    scale = CURRENT (scale);

	    *X = B_TRANSLATE_X (scale, XX);
	    *Y = B_TRANSLATE_Y (scale, YY);
	    *BUTTON = button;
	    return;
	    break;
	default:
	    break;
	}
    }
}

void
F77g_mouse_sence (X, Y, BUTTON)
    G_REAL	*X, *Y;
    int         *BUTTON;
{
    Cg_mouse_sence (X, Y, BUTTON);
}

void
g_mouse_sence__ (X, Y, BUTTON)
    G_REAL	*X, *Y;
    int         *BUTTON;
{
    Cg_mouse_sence (X, Y, BUTTON);
}

Window
g_get_window (void)
{
    X_PRIV  *priv = (X_PRIV *)g_x_device.dev_private;

    return (priv->window);
}

Display *
g_get_display (void)
{
    X_PRIV  *priv = (X_PRIV *)g_x_device.dev_private;

    return (priv->display);
}

