
static char rcsid[] = "$Id: g_hidden.c,v 1.3 1995/05/23 05:26:11 nakano Exp nakano $";

#include "g_private.h"
#include "g_bird.h"

#define SPAN(n, i, intv) \
	((((n) - (i)) % (intv)) ? ((n) - (i)) % (intv) : (intv))

static void
side (first, side_mode, data, n_x, n_y, unit_x, unit_y, x_pos, y_pos, dx, dy,
      z_pos, z_level, z_scale, distance, sth, cth, sphi, cphi)
    G_BOOL	first;
    G_SIDE_MODE	side_mode;
    G_REAL *	data;
    int		n_x, n_y, unit_x, unit_y;
    G_P_POS	x_pos, y_pos, dx, dy, z_pos;
    G_P_REAL	z_level, z_scale;
    G_P_DIM	distance;
    G_P_REAL	sth, cth, sphi, cphi;
{
    G_POS	gx[G_MAX_N_POINTS + 2], gy[G_MAX_N_POINTS + 2];
    int		n, unit, i, j;

    if (n_x)
    {
	if ((side_mode & G_SIDE_Y) == 0
	    || ((distance <= 0.0)
		 ? (cth * cphi * y_pos > 0.0)
		 : (- distance * cth * cphi * y_pos < y_pos * y_pos)) != first)

	{
	    return;
	}

	n = n_x;
	unit = unit_x;
	dy = 0.0;
    }
    else if (n_y)
    {
	if ((side_mode & G_SIDE_X) == 0
	    || ((distance <= 0.0)
		 ? (cth * cphi * x_pos < 0.0)
		 : (distance * sth * cphi * x_pos < x_pos * x_pos)) != first)
	{
	    return;
	}

	n = n_y;
	unit = unit_y;
	dx = 0.0;
    }
    else
    {
	return;
    }

    GET_XY (sth, cth, sphi, cphi, distance,
	    x_pos, y_pos, PZ (z_pos, z_level, z_scale), gx[0], gy[0]);

    j = 0;

    for (i = 1; i <= n; i ++)
    {

	GET_XY (sth, cth, sphi, cphi, distance,
		x_pos, y_pos, PZ (data[j], z_level, z_scale), gx[i], gy[i]);
	j += unit;
	x_pos += dx;
	y_pos += dy;
    }

    GET_XY (sth, cth, sphi, cphi, distance,
	    x_pos - dx, y_pos - dy, PZ (z_pos, z_level, z_scale), gx[i], gy[i]);

    SIDE_AREA ();
    Cg_polygon (gx, gy, n + 2, G_YES, G_YES);
}

static void
patch (data, unit_x, unit_y, x_pos, y_pos, dx, dy, n_x, n_y,
       z_level, z_scale, distance, sth, cth, sphi, cphi)
    G_REAL *	data;
    int		unit_x, unit_y;
    G_P_POS	x_pos, y_pos, dx, dy;
    int		n_x, n_y;
    G_P_REAL	z_level, z_scale;
    G_P_DIM	distance;
    G_P_REAL	sth, cth, sphi, cphi;
{
    G_POS	gx[G_MAX_N_POINTS], gy[G_MAX_N_POINTS];
    int		i, j;

    j = 0;

    for (i = 0; i < n_x; i ++)
    {
	GET_XY (sth, cth, sphi, cphi, distance,
		x_pos, y_pos, PZ (* data, z_level, z_scale), gx[j], gy[j]);
	x_pos += dx, data += unit_x, j ++;
    }

    for (i = 0; i < n_y; i ++)
    {
	GET_XY (sth, cth, sphi, cphi, distance,
		x_pos, y_pos, PZ (* data, z_level, z_scale), gx[j], gy[j]);
	y_pos += dy, data += unit_y, j ++;
    }

    for (i = 0; i < n_x; i ++)
    {
	GET_XY (sth, cth, sphi, cphi, distance,
		x_pos, y_pos, PZ (* data, z_level, z_scale), gx[j], gy[j]);
	x_pos -= dx, data -= unit_x, j ++;
    }

    for (i = 0; i < n_y; i ++)
    {
	GET_XY (sth, cth, sphi, cphi, distance,
		x_pos, y_pos, PZ (* data, z_level, z_scale), gx[j], gy[j]);
	y_pos -= dy, data -= unit_y, j ++;
    }

    EDGE_LINE ();
    ROOF_AREA ();
    Cg_polygon (gx, gy, j, G_YES, G_YES);
}

static void
do_hidden (x_wid, y_wid, z_wid, z_bottom, z_top, distance, theta, phi,
	   x_left_std, y_top_std, x_wid_std, y_wid_std,
	   data, n_x, n_y, unit_x, unit_y,
	   direction, side_mode, intv_x, intv_y)
    G_P_DIM	x_wid, y_wid, z_wid;
    G_P_REAL	z_bottom, z_top;
    G_P_DIM	distance;
    G_P_REAL	theta, phi;
    G_P_POS	x_left_std, y_top_std;
    G_P_DIM	x_wid_std, y_wid_std;
    G_REAL *	data;
    int		n_x, n_y, unit_x, unit_y, direction;
    G_SIDE_MODE	side_mode;
    int		intv_x, intv_y;
{
    G_P_POS	x_start, y_start, dx, dy;
    G_P_REAL	sth, cth, sphi, cphi;
    G_P_REAL	z_scale;
    G_P_POS	z_level;
    int		last_axis, i, j;
    G_REAL *	data_p;
    G_REAL *	data_s;
    G_P_POS	x, y, z, delta_x, delta_y, x_s, y_s, x1, x2, y_dummy;
    int		u_x, u_y, span_x, span_y;

    if ((intv_x + intv_y) * 2 > G_MAX_N_POINTS)
    {
	char	message[200];
	int	old = intv_x;

	intv_x = G_MAX_N_POINTS / 2 / intv_y;
	intv_x = n_x / ((n_x + intv_x - 1) / intv_x);
	sprintf (message, "too short x-interval %d adjusted to %d",
		 old, intv_x);
	g_warning ("g_hidden", message);
    }

    if (g_start_bird (x_wid, y_wid, z_wid, z_bottom, z_top,
		      distance, theta, phi,
		      x_left_std, y_top_std, x_wid_std, y_wid_std,
		      & sth, & cth, & sphi, & cphi, & last_axis,
		      & z_level, & z_scale, "g_hidden"))
    {
	return;
    }

    SET_BW_COLOR ();

    x_start = - x_wid / 2.0, y_start = - y_wid / 2.0;
    dx = x_wid / (n_x - 1), dy = y_wid / (n_y - 1);

    if (direction < 0)
    {
	dy *= -1.0;
	y_start *= -1.0;
    }

    side (G_YES, side_mode, data, 0, n_y, 0, unit_y,
	  x_start, y_start, (G_POS) 0.0, dy,
	  z_bottom, z_level, z_scale, distance, sth, cth, sphi, cphi);
    side (G_YES, side_mode, data + unit_x * (n_x - 1), 0, n_y, 0, unit_y,
	  - x_start, y_start, (G_POS) 0.0, dy,
	  z_bottom, z_level, z_scale, distance, sth, cth, sphi, cphi);
    side (G_YES, side_mode, data, n_x, 0, unit_x, 0,
	  x_start, y_start, dx, (G_POS) 0.0,
	  z_bottom, z_level, z_scale, distance, sth, cth, sphi, cphi);
    side (G_YES, side_mode, data + unit_y * (n_y - 1), n_x, 0, unit_x, 0,
	  x_start, - y_start, dx, (G_POS) 0.0,
	  z_bottom, z_level, z_scale, distance, sth, cth, sphi, cphi);

    x_s = x_start, y_s = y_start;
    u_x = unit_x, u_y = unit_y;
    delta_x = dx, delta_y = dy;
    data_p = data;

    if ((last_axis & 0x1) == 0)
    {
	x_s = - x_s;
	delta_x = - delta_x;
	data_p += u_x * (n_x - 1);
	u_x = - u_x;
    }

    if ((last_axis & 0x2) == 0)
    {
	y_s = - y_s;
	delta_y = - delta_y;
	data_p += u_y * (n_y - 1);
	u_y = - u_y;
    }

    x = 1.0, y = 0.0, z = 0.0;
    GET_XY (sth, cth, sphi, cphi, distance, x, y, z, x1, y_dummy);
    x = 0.0, y = 1.0, z = 0.0;
    GET_XY (sth, cth, sphi, cphi, distance, x, y, z, x2, y_dummy);

    if (fabs (x1) < fabs (x2))
    {
	x = x_s;

	for (i = 1; i < n_x; i += span_x)
	{
	    y = y_s;
	    data_s = data_p;
	    span_x = SPAN (n_x, i, intv_x);

	    for (j = 1; j < n_y; j += span_y)
	    {
		span_y = SPAN (n_y, j, intv_y);
		patch (data_s, u_x, u_y, x, y, delta_x, delta_y, span_x, span_y,
		       z_level, z_scale, distance, sth, cth, sphi, cphi);
		data_s += u_y * span_y;
		y += delta_y * span_y;
	    }

	    data_p += u_x * span_x;
	    x += delta_x * span_x;
	}
    }
    else
    {
	y = y_s;

	for (i = 1; i < n_y; i += span_y)
	{
	    x = x_s;
	    data_s = data_p;
	    span_y = SPAN (n_y, i, intv_y);

	    for (j = 1; j < n_x; j += span_x)
	    {
		span_x = SPAN (n_x, j, intv_x);
		patch (data_s, u_x, u_y, x, y, delta_x, delta_y, span_x, span_y,
		       z_level, z_scale, distance, sth, cth, sphi, cphi);
		data_s += u_x * span_x;
		x += delta_x * span_x;
	    }

	    data_p += u_y * span_y;
	    y += delta_y * span_y;
	}
    }

    side (G_NO, side_mode, data, 0, n_y, 0, unit_y,
	  x_start, y_start, (G_POS) 0.0, dy,
	  z_bottom, z_level, z_scale, distance, sth, cth, sphi, cphi);
    side (G_NO, side_mode, data + unit_x * (n_x - 1), 0, n_y, 0, unit_y,
	  - x_start, y_start, (G_POS) 0.0, dy,
	  z_bottom, z_level, z_scale, distance, sth, cth, sphi, cphi);
    side (G_NO, side_mode, data, n_x, 0, unit_x, 0,
	  x_start, y_start, dx, (G_POS) 0.0,
	  z_bottom, z_level, z_scale, distance, sth, cth, sphi, cphi);
    side (G_NO, side_mode, data + unit_y * (n_y - 1), n_x, 0, unit_x, 0,
	  x_start, - y_start, dx, (G_POS) 0.0,
	  z_bottom, z_level, z_scale, distance, sth, cth, sphi, cphi);

    g_end_bird ();
}

void
Cg_hidden (x_wid, y_wid, z_wid, z_bottom, z_top, distance, theta, phi,
	  x_left_std, y_top_std, x_wid_std, y_wid_std,
	  data, n_x, n_y, direction, side_mode, intv_x, intv_y)
    G_P_DIM	x_wid, y_wid, z_wid;
    G_P_REAL	z_bottom, z_top;
    G_P_DIM	distance;
    G_P_REAL	theta, phi;
    G_P_POS	x_left_std, y_top_std;
    G_P_DIM	x_wid_std, y_wid_std;
    G_REAL *	data;
    int		n_x, n_y, direction;
    G_SIDE_MODE	side_mode;
    int		intv_x, intv_y;
{
    do_hidden (x_wid, y_wid, z_wid, z_bottom, z_top, distance, theta, phi,
	       x_left_std, y_top_std, x_wid_std, y_wid_std,
	       data, n_x, n_y, n_y, 1,
	       direction, side_mode, intv_x, intv_y);
}

void
F77g_hidden (x_wid, y_wid, z_wid, z_bottom, z_top, distance, theta, phi,
	   x_left_std, y_top_std, x_wid_std, y_wid_std,
	   data, n_x, n_y, direction, side_mode, intv_x, intv_y)
    G_DIM	*x_wid, *y_wid, *z_wid;
    G_REAL	*z_bottom, *z_top;
    G_DIM	*distance;
    G_REAL	*theta, *phi;
    G_POS	*x_left_std, *y_top_std;
    G_DIM	*x_wid_std, *y_wid_std;
    G_REAL	*data;
    int		*n_x, *n_y, *direction;
    G_SIDE_MODE	*side_mode;
    int		*intv_x, *intv_y;
{
    do_hidden (*x_wid, *y_wid, *z_wid, *z_bottom, *z_top,
	       *distance, *theta, *phi,
	       *x_left_std, *y_top_std, *x_wid_std, *y_wid_std,
	       data, *n_x, *n_y, 1, *n_x,
	       *direction, *side_mode, *intv_x, *intv_y);
}

void
g_hidden__ (x_wid, y_wid, z_wid, z_bottom, z_top, distance, theta, phi,
	   x_left_std, y_top_std, x_wid_std, y_wid_std,
	   data, n_x, n_y, direction, side_mode, intv_x, intv_y)
    G_DIM	*x_wid, *y_wid, *z_wid;
    G_REAL	*z_bottom, *z_top;
    G_DIM	*distance;
    G_REAL	*theta, *phi;
    G_POS	*x_left_std, *y_top_std;
    G_DIM	*x_wid_std, *y_wid_std;
    G_REAL	*data;
    int		*n_x, *n_y, *direction;
    G_SIDE_MODE	*side_mode;
    int		*intv_x, *intv_y;
{
    do_hidden (*x_wid, *y_wid, *z_wid, *z_bottom, *z_top,
	       *distance, *theta, *phi,
	       *x_left_std, *y_top_std, *x_wid_std, *y_wid_std,
	       data, *n_x, *n_y, 1, *n_x,
	       *direction, *side_mode, *intv_x, *intv_y);
}

