
static char rcsid[] = "$Id: g_marker.c,v 1.4 1995/05/23 05:26:15 nakano Exp nakano $";

#include "g_private.h"

#define SQRT3	(1.732050807569)

void
Cg_marker (x, y)
    G_P_POS	x, y;
{
    MARKER_PROP *	prop;
    LINE_PROP *		line_prop;
    AREA_PROP *		area_prop;
    LINE_PROP		saved_line;
    AREA_PROP		saved_area;
    G_POINT		saved_point;
    G_POS		w, h;
    G_POS		tri_x[3];
    G_POS		tri_y[3];

    g_check_init ();

    prop = CURRENT (marker);
    line_prop = CURRENT (line);
    area_prop = CURRENT (area);
    saved_line = * line_prop;
    line_prop -> color = prop -> color;
    line_prop -> width = 1;
    line_prop -> type = G_LINE_SOLID;
    CALL_PROC (validate_line, NULL);

    if (prop -> size == 0)
    {
	Cg_point (x, y);
	* line_prop = saved_line;
	CALL_PROC (validate_line, NULL);
	return;
    }

    saved_area = * area_prop;
    area_prop -> color = prop -> color;
    CALL_PROC (validate_area, NULL);

    w = prop -> size / CURRENT (scale) -> x_scale;
    h = prop -> size / CURRENT (scale) -> y_scale;

    saved_point = g_context.point;

    switch (prop -> type)
    {
	case G_MARKER_X:
	    w *= 0.4;
	    h *= 0.4;
	    Cg_move (x - w, y - h);
	    Cg_plot (x + w, y + h);
	    Cg_move (x + w, y - h);
	    Cg_plot (x - w, y + h);
	    break;
	case G_MARKER_F_TRIANGLE:
	    tri_x[0] = x;
	    tri_y[0] = y - h * 2.0 / 3.0;
	    tri_x[1] = x - w / SQRT3;
	    tri_y[1] = y + h / 3.0;
	    tri_x[2] = x + w / SQRT3;
	    tri_y[2] = y + h / 3.0;
	    Cg_polygon (tri_x, tri_y, 3, G_NO, G_YES);
	    break;
	case G_MARKER_F_BOX:
	    w *= 0.45;
	    h *= 0.45;
	    Cg_box (x - w, x + w, y + h, y - h, G_NO, G_YES);
	    break;
	case G_MARKER_F_CIRC:
	    Cg_circle (x, y, w / 2.0, G_NO, G_YES);
	    break;
	case G_MARKER_STAR:
	    w *= SQRT3 / 4.0;
	    h /= 2.0;
	    Cg_move (x, y - h);
	    Cg_plot (x, y + h);
	    h /= 2.0;
	    Cg_move (x + w, y - h);
	    Cg_plot (x - w, y + h);
	    Cg_move (x - w, y - h);
	    Cg_plot (x + w, y + h);
	    break;
	case G_MARKER_CIRC:
	    Cg_circle (x, y, w / 2.0, G_YES, G_NO);
	    break;
	case G_MARKER_BOX:
	    w *= 0.45;
	    h *= 0.45;
	    Cg_box (x - w, x + w, y + h, y - h, G_YES, G_NO);
	    break;
	case G_MARKER_TRIANGLE:
	    tri_x[0] = x;
	    tri_y[0] = y - h * 2.0 / 3.0;
	    tri_x[1] = x - w / SQRT3;
	    tri_y[1] = y + h / 3.0;
	    tri_x[2] = x + w / SQRT3;
	    tri_y[2] = y + h / 3.0;
	    Cg_polygon (tri_x, tri_y, 3, G_YES, G_NO);
	    break;
	case G_MARKER_PLUS:
	    w /= 2.0;
	    h /= 2.0;
	    Cg_move (x - w, y);
	    Cg_plot (x + w, y);
	    Cg_move (x, y - h);
	    Cg_plot (x, y + h);
	    break;
    }

    * line_prop = saved_line;
    * area_prop = saved_area;
    g_context.point = saved_point;
    CALL_PROC (validate_line, NULL);
    CALL_PROC (validate_area, NULL);
}

void
F77g_marker (x, y)
    G_POS *	x;
    G_POS *	y;
{
    Cg_marker (* x, * y);
}

void
g_marker__ (x, y)
    G_POS *	x;
    G_POS *	y;
{
    Cg_marker (* x, * y);
}

