
static char rcsid[] = "$Id: g_polygon.c,v 1.4 1995/05/23 05:26:21 nakano Exp nakano $";

#include "g_private.h"

void
Cg_polygon (x, y, n, edge, fill)
    G_POS	x[];
    G_POS	y[];
    int		n;
    G_BOOL	edge;
    G_BOOL	fill;
{
    G_POLYGON_DEF	packet;
    int			i;
    SCALE *		scale;

    g_check_init ();
    scale = CURRENT (scale);

    if (G_MAX_N_POINTS < n)
    {
	char	message[200];

	sprintf (message, "too many points %d trancated to %d",
		 n, G_MAX_N_POINTS);
	g_warning ("g_polygon", message);

	n = G_MAX_N_POINTS;
    }

    for (i = 0; i < n; i ++)
    {
	packet.points[i].x = TRANSLATE_X (scale, x[i]);
	packet.points[i].y = TRANSLATE_Y (scale, y[i]);
    }

    packet.n_points = n;
    packet.edge = edge;
    packet.fill = fill;

    CALL_PROC (polygon, & packet);
}

void
F77g_polygon (x, y, n, edge, fill)
    G_POS	x[];
    G_POS	y[];
    int *	n;
    G_BOOL *	edge;
    G_BOOL *	fill;
{
    Cg_polygon (x, y, * n, * edge, * fill);
}

void
g_polygon__ (x, y, n, edge, fill)
    G_POS	x[];
    G_POS	y[];
    int *	n;
    G_BOOL *	edge;
    G_BOOL *	fill;
{
    Cg_polygon (x, y, * n, * edge, * fill);
}

