c
c	$Id: fproto.c,v 1.2 1995/05/23 07:08:26 nakano Exp nakano $
c
c	Test program for GLSC library
c
c		F77 version
c
c

#include <g_f77name.h>

c------------------------------------------------------------------------
	program ftest
c------------------------------------------------------------------------

	implicit real*4 (a-h, o-z)

	include GLSC_FTN_H

	parameter (mmax = 5000, imax = 40, jmax = 40)

	dimension x(0:mmax), y(0:mmax)
	character text(256)
	dimension array(0:imax,0:jmax)

	data PI /3.141592654e0/, N /30/

c   Initialization and definitions
	call g_init ('Meta', 4, 250.0e0, 160.0e0)
	call g_device (G_BOTH)
	call g_def_scale (0, 0.0e0, 1.0e0, 0.0e0, 1.0e0,
     1			  30.0e0, 70.0e0, 100.0e0, 72.0e0)
	call g_def_scale (1, 0.0e0, 1.0e0, 0.0e0, 1.0e0,
     1			  30.0e0, 30.0e0, 100.0e0, 100.0e0)
	call g_def_scale (2, -1.0e0, 1.0e0, -1.0e0, 1.0e0,
     1			  20.0e0, 30.0e0, 80.0e0, 80.0e0)
	call g_def_scale (3, 0.0e0, N*PI, -1.0e0, 1.0e0,
     1			  110.0e0, 30.0e0, 130.0e0, 80.0e0)
	call g_def_scale (4, -1.0e0, 1.0e0, -1.0e0, 1.0e0,
     1			  30.0e0, 30.0e0, 100.0e0, 100.0e0)
	call g_def_line (0, G_BLACK, 0, G_LINE_SOLID)
	call g_def_line (1, G_RED, 0, G_LINE_SOLID)
	call g_def_line (2, G_GREEN, 0, G_LINE_DASHED)
	call g_def_line (3, G_BLUE, 0, G_LINE_SOLID)
	call g_def_text (0, G_BLACK, G_FONT_TIMES_8)
	call g_def_text (1, G_RED, G_FONT_TIMES_12)
	call g_def_text (2, G_GREEN, G_FONT_TIMES_18)
	call g_def_text (3, G_BLUE, G_FONT_TIMES_24)

c   Hinomaru and text
	call g_cls ()
	do 100 i = 0, 3
	    call g_sel_text (i)
	    call g_text (30.0e0, 20.0e0+(10.0*i),
     1			 'Test Hinomaru no Hata.', 22)
100	continue
	call g_sel_scale (0)
	call g_area_color (G_WHITE)
	call g_box (0.0e0, 1.0e0, 0.0e0, 1.0e0, G_YES, G_YES)
	call g_area_color (G_RED)
	call g_circle (0.5e0, 0.5e0, 0.18e0, G_NO, G_YES)

	do 200 i = 0, 9
	    a = i*0.2e0
	    call g_sformat (text, length, 'a = %f', a)
	    call g_text (160.0e0, 20.0e0+10.0*i, text, length)
200	continue
	call g_sleep (3.0e0)

c   Various lines and boxes
	call g_cls ()
	call g_sel_scale (1)
	call g_box (0.0e0, 1.0e0, 0.0e0, 1.0e0, G_YES, G_NO)
	call g_area_color (G_GREEN)
	call g_box (0.0e0, 0.5e0, 0.5e0, 1.0e0, G_YES, G_YES)
	call g_area_color (G_RED)
	call g_box (0.5e0, 1.0e0, 0.0e0, 0.5e0, G_YES, G_YES)
	call g_area_color (G_BLUE)
	call g_box (0.5e0, 1.0e0, 0.5e0, 1.0e0, G_YES, G_YES)

	do 300 i = 0, 7
	    call g_line_width (2*(i+1))
	    call g_line_type (i)
	    call g_line_color (i)
	    call g_move (0.1e0, 0.1+i/7.0*0.8e0)
	    call g_plot (0.9e0, 0.1+i/7.0*0.8e0)
300	continue

	do 400 i = 0, 7
	    call g_line_width (2*(7-i+1))
	    call g_line_type (7-i)
	    call g_line_color (7-i)
	    call g_move (0.1+(7-i)/7.0*0.8e0, 0.1e0)
	    call g_plot (0.1+(7-i)/7.0*0.8e0, 0.9e0)
400	continue
	call g_sleep (3.0e0)

c   Graphs
	a =-0.04e0
	dt = N*PI/mmax

	do 500 i = 0, mmax
		t = dt*i
		x(i) = exp(a*t)*cos(t)
		y(i) = exp(a*t)*sin(t)
500	continue

	call g_sel_scale (2)
	call g_cls ()
	call g_sel_line (0)
	call g_box (-1.0e0, 1.0e0, -1.0e0, 1.0e0, G_YES, G_NO)
	call g_move (-1.0e0,  0.0e0)
	call g_plot ( 1.0e0,  0.0e0)
	call g_move ( 0.0e0, -1.0e0)
	call g_plot ( 0.0e0,  1.0e0)
	call g_sel_line (1)
	call g_polyline (x, y, mmax+1)
	call g_sel_scale (3)
	call g_sel_line (0)
	call g_box (0.0e0, N*PI, -1.0e0, 1.0e0, G_YES, G_NO)
	call g_move (0.0e0, 0.0e0)
	call g_plot (N*PI, 0.0e0)
	call g_sel_line (2)
	call g_data_plot (0.0e0, N*PI, x, mmax+1)
	call g_sel_line (3)
	call g_data_plot (0.0e0, N*PI, y, mmax+1)
	call g_marker_size (5)
	call g_marker_color (G_RED)
	call g_marker_type (2)
	do 600 i = 0, 10
	    call g_marker (i*dt*(mmax/10),
     1			   (x(i*(mmax/10)) +y(i*(mmax/10)))/2)
600	continue
	call g_sleep (3.0e0)

c   Markers
	dt = 2*PI/6
	do 700 i = 0, 5
		t = dt*i
		x(i) = cos(t)
		y(i) = sin(t)
700	continue

	call g_cls ()
	call g_sel_scale (4)
	call g_area_color (G_WHITE)
	call g_line_width (3)
	call g_line_color (G_RED)
	call g_circle (0.0e0, 0.0e0, 1.2e0, G_YES, G_YES)
	call g_line_color (G_CYAN)
	call g_polygon (x, y, 6, G_YES, G_YES)

	call g_marker_color (G_BLACK)
	call g_marker_size (10)
	do 800 i = -4, 4
	    call g_marker_type (i)
	    call g_marker (0.5*cos(2*PI/9*i), 0.5*sin(2*PI/9*i))
	    call g_marker (cos(2*PI/9*i), sin(2*PI/9*i))
800	continue
	call g_sleep (3.0e0)

c   Contour lines and bird eyes view
	dx = PI*4/imax
	dy = PI*3/jmax
	do 1000 j = 0, jmax
		yy = dy*(j-jmax/2)
		do 900 i = 0, imax
			xx = dx*(i-imax/2)
			array(i,j) = sin(xx-0.3)*cos(yy-0.2)
900		continue
1000	continue

	call g_cls ()
	call g_sel_scale (4)
	call g_sel_line (0)
	call g_box (-1.0e0, 1.0e0, -1.0e0, 1.0e0, G_YES, G_NO)
	do 1100 i = 1, 6
	    call g_line_color (i)
	    call g_contln (-1.0e0, 1.0e0, -1.0e0, 1.0e0,
     1			   array, imax+1, jmax+1, 0.32e0*i-1.12)
1100	continue
	call g_sleep (3.0e0)

	call g_cls ()
	call g_bird_view (1.0e0, 1.0e0, 0.4e0, -1.0e0, 1.0e0,
     1			  5.0e0, 25.0e0, 20.0e0, 20.0e0, 20.0e0,
     2			  150.0e0, 100.0e0, array, imax+1, jmax+1, 1)
	call g_sleep (3.0e0)

	call g_cls ()
	call g_fake_bird_view (-1.0e0, 1.0e0, 0.8e0, 0.6e0,
     1			       20.0e0, 20.0e0, 150.0e0, 100.0e0,
     2			       array, imax+1, jmax+1, 1)
	call g_sleep (3.0e0)

	call g_cls ()
	call g_hidden (1.0e0, 1.0e0, 0.4e0, -1.0e0, 1.0e0,
     1		       5.0e0, 25.0e0, 20.0e0, 20.0e0, 20.0e0,
     2		       150.0e0, 100.0e0,
     3		       array, imax+1, jmax+1, 1, G_SIDE_NONE, 2, 1)
	call g_sleep (3.0e0)

	call g_cls ()
	call g_fake_hidden (-1.0e0, 1.0e0, 0.8e0, 0.6e0,
     1			    20.0e0, 20.0e0, 150.0e0, 100.0e0,
     2			    array, imax+1, jmax+1, 1, G_SIDE_NONE, 2, 1)
	call g_sleep (3.0e0)

c   Termination
	call g_term ()

	stop
	end

c   End of file
