/* This program is in the public domain.      */
/* Masaharu NAGAYAMA, 2009.01.19, ver.1.0     */
#include <stdio.h>
#include<stdlib.h>
#include<unistd.h>
#include<GL/glut.h>
#include<GL/glu.h>
#include<GL/gl.h>

/* 摜̃sNZ */
#define WIDTH 500  
#define HEIGHT 500 

/* lvZɕKvȃp[^ */
/* RlvZ̓eɂďKv */
#define MAXTIME 10
#define DT 0.0005
#define E 0.8
#define G 9.8

/* KvȐ錾 */
GLuint startList;
void display(double y);

/* 摜PPMt@CƂĕۑ */
void save_file(FILE *f){
  if (f) {
      int i, x, y;
      GLubyte *ptr;
      ptr = malloc( WIDTH * HEIGHT * 4 );

      glReadPixels(0, 0, WIDTH, HEIGHT, GL_RGBA,
                GL_UNSIGNED_BYTE, ptr);
      fprintf(f,"P6\n");
      fprintf(f,"# ppm-file created\n");
      fprintf(f,"%i %i\n", WIDTH,HEIGHT);
      fprintf(f,"255\n");
      for (y = HEIGHT-1; y >= 0; y--) {
        for (x = 0; x < WIDTH; x++) {
          i = (y*WIDTH + x) * 4;
          fputc(ptr[i], f);   /* write red */
          fputc(ptr[i+1], f); /* write green */
          fputc(ptr[i+2], f); /* write blue */
        }
      }
    free(ptr);
  }
}
/* PPMt@C  JPEGt@CFImageMagickgĂ*/
void change_image_format(char *in, char *out)
{
   char string[300];
   sprintf(string, "convert %s %s", in, out);
   system(string);
}

/* lvZ镔 */
double f1(double t, double x, double v)
{
  return - G;
}

double f2(double t, double x, double v)
{
  return v;
}
void rakka()
{
  int i;
  double x, v;
  double new_x, new_v;
  double t;
  double dt = DT;
  double e = E;
  double maxtime = MAXTIME;
  int n = (int)(maxtime / dt);

  char ppmfile[BUFSIZ],jpegfile[BUFSIZ];
  FILE *fp;

  x = 0.;
  v = 4.9;

  for(i = 1; i <= n; i++) {
    t = dt * i;
    new_x = x + dt * f2(t, x, v);
    new_v = v + dt * f1(t, x, v);
    x = new_x;
    v = new_v;
    //printf("%lf %lf\n", t, x);
    display(x);
    if(x <= 0) {
      v = - e * v;
      x = 0.;
    }
	
    if((i-1)%50 == 0){ 
      sprintf(ppmfile, "./image/Image%04d.ppm",(i-1)/50);
      sprintf(jpegfile,"./image/Image%04d.jpg",(i-1)/50);
      if ((fp = fopen(ppmfile, "w")) == NULL){
        perror(ppmfile);
        exit(1);
      }
      save_file(fp);
      fclose(fp);
      change_image_format(ppmfile,jpegfile);
      unlink(ppmfile);
    }
  }
  return;
}

/* G[ */
void errorCallback(GLenum errorCode)
{
  const GLubyte *estring;
  
  estring = gluErrorString(errorCode);
  fprintf(stderr,"Quadric Error: %s\n",estring);
  exit(0);
}

/* ʂ̏ */
void init(void)
{
  GLUquadricObj *qobj;
  GLfloat mat_ambient[] = { 1.0, 0.0, 0.0,1.0 };
  GLfloat mat_specular[] = { 1.0, 1.0, 1.0,1.0 };
  GLfloat mat_shininess[] = { 50.0 };
  GLfloat light_position[] = {1.0, 1.0, 1.0, 0.0 };
  GLfloat model_ambient[] = { 0.5, 0.5, 0.5, 1.0 };
  
  glClearColor(1.0, 1.0, 1.0, 1.0);
  
  glMaterialfv(GL_FRONT, GL_AMBIENT, mat_ambient);
  glMaterialfv(GL_FRONT, GL_SPECULAR, mat_specular);
  glMaterialfv(GL_FRONT, GL_SHININESS, mat_shininess);
  glLightfv(GL_LIGHT0, GL_POSITION, light_position);
  glLightModelfv(GL_LIGHT_MODEL_AMBIENT, model_ambient);
  
  glEnable(GL_LIGHTING);
  glEnable(GL_LIGHT0);
  glEnable(GL_DEPTH_TEST);
  
  startList = glGenLists(1);
  qobj = gluNewQuadric();
  /* gluQuadricCallback(qobj, GLU_ERROR, errorCallback); */
  gluQuadricDrawStyle(qobj,GLU_FILL);
  gluQuadricNormals(qobj, GLU_SMOOTH);
  glNewList(startList, GL_COMPILE);
  gluSphere(qobj, 0.1, 10, 10);
  glEndList();
}

/* Fԑ厖 */
void display(double y)
{
  glClear(GL_COLOR_BUFFER_BIT| GL_DEPTH_BUFFER_BIT);
  glPushMatrix();
  glEnable(GL_LIGHTING);
  glShadeModel(GL_SMOOTH);
  glTranslatef(0.0, y, 0.0);
  glCallList(startList);
  glPopMatrix();
  glFlush();
}

void reshape(int w, int h)
{
  glViewport(0, 0, (GLsizei) w, (GLsizei) h);
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  
  if( w <= h ){
    
    glOrtho(-2.5, 2.5, -2.5*(GLfloat)h/(GLfloat)w, 2.5*(GLfloat)h/(GLfloat)w,-10.0,10.0);
  }else{
    glOrtho(-2.5*(GLfloat)h/(GLfloat)w, 2.5*(GLfloat)h/(GLfloat)w,-2.5, 2.5,-10.0,10.0);
  }

  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
}

/* L[{[h̓ */
void keyboard(unsigned char key, int x, int y)
{
  switch( key ){
  case 27:
    exit(0);
    break;
  }
}

/* C[v */
int main(int argc, char *argv[])
{
  glutInit(&argc, argv);
  glutInitDisplayMode(GLUT_SINGLE| GLUT_RGB| GLUT_DEPTH);
  glutInitWindowSize(500, 500);
  glutInitWindowPosition(200,200);
  glutCreateWindow(argv[0]);
  init();
  glutDisplayFunc(rakka);
  glutReshapeFunc(reshape);
  glutKeyboardFunc(keyboard);
  glutMainLoop();
  return 0;
}
