#include <stdio.h>
#include <math.h>
void mk_color_full(double (*)[], double[], double[], double[], 
	int, double, double, int, int, int, int);
void draw_(int, int, int, double, double, double *, double *, 
	double *, char *, char *);

#define TIME 500  /* vZ */
#define CUT 10    /*񖈂ɏo͂邩 */
#define DT 0.00001    /*t */
#define NX 100   /* vf̌ */
#define NY 50   /* vf̌ */

#define LENGTH_X 1   /*  */
#define LENGTH_Y 0.5   /*  */
#define DX 1  /* gUW */
#define DY 1  /* gUW */

/*OpenGL*/
#define nx0 0
#define ny0 0
#define mod 1

void initial_u(double u[NX + 1][NY + 1],
	       double dx, double dy, int nx, int ny)
{
  int i, j;
  double pi = acos(-1.);
  double x, y;

  for(i = 0; i <= nx; i++) {
    x = dx * i;
    for(j = 0; j <= ny; j++) {
      y = dy * j;
      u[i][j] = 4 * cos(3 * pi * x) * cos(2 * pi * y);
    }
  }
}

/* LŨvO */
void lu_divide(double a[], double b[], double c[],
	 double l[][2], double u[], int n)
{
  int i;

  l[0][0] = a[0];
  for(i = 1; i <= n; i++) {
    l[i][1] = b[i];
  }
  for(i = 0; i <= n - 1; i++) {
    u[i] = c[i] / l[i][0];
    l[i + 1][0] = a[i + 1] - u[i] * l[i + 1][1];
  }
}

/* LU x = b ̉@*/
void lu_solve(double y[], double b[], double l[][2], double u[],
		double x[], int n)
{
  int i;

  y[0] = b[0] / l[0][0];
  for(i = 1; i <= n; i++) {
    y[i] = (b[i] - l[i][1] * y[i - 1]) / l[i][0];
  }

  x[n] = y[n];
  for(i = n - 1; i >= 0; i--) {
    x[i] = y[i] - u[i] * x[i + 1];
  }
}

int main()
{
  int i, j, k;
  int time = TIME;
  int nx = NX;
  int ny = NY;
  int cut = CUT;
  double Dx = DX;
  double Dy = DY;
  double length_x = LENGTH_X;
  double length_y = LENGTH_Y;
  double dt = DT;
  double dx = length_x / (double)nx;
  double dy = length_y / (double)ny;
  double rx = dt / (dx * dx);
  double ry = dt / (dy * dy);
  double old_u[NX + 1][NY + 1], u[NX + 1][NY + 1];
  double um[NX + 1][NY + 1];
  double umx[NY + 1][NX + 1];
  double ax[NX + 1], bx[NX + 1], cx[NX + 1];
  double ay[NY + 1], by[NY + 1], cy[NY + 1];
  double Lx[NX + 1][2], Ux[NX], Bx[NX + 1];
  double Ly[NY + 1][2], Uy[NY], By[NY + 1];
  double Yx[NX + 1], Yy[NY + 1];
  double drx = Dx * rx;
  double dry = Dy * ry;

  /*OpenGL*/
  int Mgx, Mgy;
  double dgx, dgy;
  double rr[(NX + 1) * (NY + 1)];
  double gg[(NX + 1) * (NY + 1)];
  double bb[(NX + 1) * (NY + 1)];
  double umax = 1.;
  double umin = -1.;


  /*OpenGL*/
  Mgx = NX / mod;
  Mgy = NY / mod;
  dgx = dx * (double)mod;
  dgy = dy * (double)mod;

  for(i = 0; i <= nx; i++) {
    ax[i] = 2 * (1 + drx);
    bx[i] = - drx;
    cx[i] = - drx;
  }
  cx[0] = - 2 * drx;
  bx[nx] = - 2 * drx;

  for(i = 0; i <= ny; i++) {
    ay[i] = 2 * (1 + dry);
    by[i] = - dry;
    cy[i] = - dry;
  }
  cy[0] = - 2 * dry;
  by[ny] = - 2 * dry;

  initial_u(old_u, dx, dy, nx, ny);
  initial_u(u, dx, dy, nx, ny);

  /*OpenGL*/
  umax = u[0][0];
  umin = u[0][0];
  for(i=0; i<=NX; i+=mod){                       
    for(j=0; j<=NY; j+=mod){                        
      if(umax < u[i][j])     umax = u[i][j];
      if(umin > u[i][j])     umin = u[i][j];
    }
  }
  mk_color_full(u, rr, gg, bb, mod, umax, umin, nx0, nx, ny0, ny);
  draw_(0, Mgx, Mgy, dgx, dgy, rr, gg, bb, "u", "image");


  lu_divide(ax, bx, cx, Lx, Ux, nx);
  lu_divide(ay, by, cy, Ly, Uy, ny);

  for(i = 1; i < time; i++) {
    for(k = 0; k <= nx; k++) {
      Bx[k] = 2 * (1 - dry) * u[k][0] + 2 * dry * u[k][1];
    }
    lu_solve(Yx, Bx, Lx, Ux, umx[0], nx);

    for(k = 0; k <= nx; k++) {
      Bx[k] = 2 * (1 - dry) * u[k][ny] + 2 * dry * u[k][ny - 1];
    }    
    lu_solve(Yx, Bx, Lx, Ux, umx[ny], nx);

    for(j = 1; j <= ny - 1; j++) {
      for(k = 0; k <= nx; k++) {
        Bx[k] = dry * u[k][j - 1] + 2 * (1 - dry) * u[k][j] + dry * u[k][j + 1];
      }
      lu_solve(Yx, Bx, Lx, Ux, umx[j], nx);
    }
    for(j = 0; j <= ny; j++) {
      for(k = 0; k <= nx; k++) { 
        um[k][j] = umx[j][k];
      }
    }

    for(k = 0; k <= ny; k++) {
      By[k] = 2 * (1 - drx) * um[0][k] + 2 * drx * um[1][k];
    }
    lu_solve(Yy, By, Ly, Uy, u[0], ny);

    for(k = 0; k <= ny; k++) {
      By[k] = 2 * (1 - drx) * um[nx][k] + 2 * drx * um[nx - 1][k];
    }    
    lu_solve(Yy, By, Ly, Uy, u[nx], ny);

    for(j = 1; j <= nx - 1; j++) {
      for(k = 0; k <= ny; k++) {
        By[k] = drx * um[j - 1][k] + 2 * (1 - drx) * um[j][k] + drx * um[j + 1][k];
      }
      lu_solve(Yy, By, Ly, Uy, u[j], ny);
    }

    if(i % cut == 0) {
      /*OpenGL*/
      mk_color_full(u, rr, gg, bb, mod, umax, umin, nx0, nx, ny0, ny);
      draw_(i / cut, Mgx, Mgy, dgx, dgy, rr, gg, bb, "u", "image");
    }
  }
  return 0;
}
