#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#define dt 0.0005
#define N 10
#define T 1000

int main()
{
  double u[N+1], new_u[N+1];
  int i, j;
  double dx = 1. / (float)N;
  double r = dt / (dx * dx);
  FILE *gpid;

  /* gnuplot J */
  if((gpid =  popen("gnuplot -persist", "w")) == NULL) {
    printf("I can't find gnuplot.\n");
    exit(1);
  }

  /* y̕`̈Œ */
  fprintf(gpid, "set yrange[-4:4]\n");

  for(i = 0; i <= N; i++){
    u[i] = 4 * cos(M_PI * i * dx);
  }

  for(j = 0; j < T; j++){
    /* Mz@ŉ*/
    for(i = 1; i < N; i++){
      new_u[i] = r * u[i - 1] + (1. - 2. * r) * u[i] + r * u[i + 1];
    }
    new_u[0] = 2. * r * u[1] + (1. - 2. * r) * u[0];
    new_u[N] = 2. * r * u[N - 1] + (1. - 2. * r) * u[N];
    
    for(i = 0; i <= N; i++){
      u[i] = new_u[i];
    }

    /* gnuplot ŃOt` */
    fprintf(gpid, "plot '-' w l t '%d'\n", j);
    for(i = 0; i <= N; i++){
      fprintf(gpid, "%lf %lf\n", i * dx, u[i]);
    }
    fprintf(gpid, "e\n");
    fflush(gpid);
  }

  /* Ō̉ʂ10bÎ~ */
  /* CꂩĂяoƂ pause -1 Ȃ̂Œ */
  fprintf(gpid, "pause 10\n");

  /* gnuplot  */
  pclose(gpid);

  return 0;
}

